
 COMMENT / -----------------------


  8000 -  FFFF  CODE
 18000 - 1FFFF  SPR PATTERN
 28000 - 2FFFF  BG PATTERN

  MEMORY USE

    00H -  40H VAR
    40H -  60H TEMP VAR

   100H - 200H STACK
   200H - 300H SPRITE BUFFER

  6800H - 6C00H SPR PAT

 ------------------------------- /

;---------------------------------
;---------------------------------
DMA_STATUS      EQU     4048H
DMA_SRC_BANK    EQU     4049H
DMA_SRC_LO      EQU     404AH
DMA_SRC_HI      EQU     404BH
DMA_DEST_LO     EQU     404CH
DMA_DEST_HI     EQU     404DH
DMA_LENG_LO     EQU     404EH
DMA_LENG_HI     EQU     404FH
;---------------------------------
DMA_ENABLE      EQU     10000000B
DMA_VRAM        EQU     11000000B
DMA_MEMCPY      EQU     11100000B
;---------------------------------
R0              EQU     00H
R0H             EQU     01H
R1              EQU     02H
R1H             EQU     03H
R2              EQU     04H
R2H             EQU     05H
R3              EQU     06H
R3H             EQU     07H
R4              EQU     08H
R4H             EQU     09H
R5              EQU     0AH
R5H             EQU     0BH
TT              EQU     0CH
TX              EQU     0DH
TY              EQU     0EH
BANK            EQU     0FH
;---------------------------------
SCROLL_X        EQU     10H
SCROLL_Y        EQU     11H
VBLANK_FLAG     EQU     12H
RG2000          EQU     13H
RG2001          EQU     14H
VBLANK_CNT      EQU     15H
SPR_X           EQU     16H
SPR_XH          EQU     17H
SPR_Y           EQU     18H
SPR_YH          EQU     19H
SPR_PAT_READY   EQU     1AH
SPR_ACTION_PTR  EQU     1BH
SPR_ACTION_PTRH EQU     1CH
SPR_DELAY       EQU     1DH
SPR_DELAYH      EQU     1EH
;---------------------------------
SPR_PAT_BUFF    EQU     6800H
;---------------------------------
        MACFIRST ON
;---------------------------------
CALL    MACRO   NN
        JSR     NN
        ENDM
;---------------------------------
LDA_W#  MACRO   RR,NN
        LDA     #<NN
        STA     RR
        LDA     #>NN
        STA     RR+1
        ENDM
;---------------------------------
LDA_RY  MACRO   RR,NN
        LDY     NN
        LDA     (RR),Y
        ENDM
;---------------------------------
NEG_A   MACRO
        XOR     #-1
        CLC
        ADC     #1
        ENDM
;---------------------------------
REG_REG MACRO   R1,R2
        LDA     R2
        STA     R1
        LDA     R2+1
        STA     R1+1
        ENDM
;---------------------------------
REG_ASL MACRO   R
        ASL     R
        ROL     R+1
        ENDM
;---------------------------------
REG_ADD MACRO   R,N
        LDA     R
        CLC
        ADC     N
        STA     R
        JR      NC,?L#
        INC     R+1
?L#
        ENDM
;---------------------------------
REG_DEC MACRO   R
        LDA     R
        JR      NZ,?L#
        DEC     R+1
?L#
        DEC     R
        ENDM
;---------------------------------
REG_INC MACRO   R
        INC     R
        JR      NZ,?L#
        INC     R+1
?L#
        ENDM
;---------------------------------
REG_REG_ADD16 MACRO R1,R2
        LDA     R1
        CLC
        ADC     R2
        STA     R1
        LDA     R1+1
        ADC     R2+1
        STA     R1+1
        ENDM
;---------------------------------

;---------------------------------
        ORG     8000H
;---------------------------------
        DB      0
;---------------------------------
        ORG     9000H
;=================================
                                                                                                                           ; SUB:
;=================================
POWER_ON:

        SEI
        CLD

        LDX     #FFH
        TXS

        LDA     #65H
        LDX     #76H
        STA     4031H
        STX     4031H

        LDA     #0
        STA     2000H
        STA     2001H
        STA     4015H

        LDA     #10001000B      ; 16 COLOR MODE
        STA     2008H

        LDA     #10000000B      ; HIDDEN DMA FUNCTION ENABLE
        STA     4020H

        CALL    DOWNLOAD_PAT
        CALL    DOWNLOAD_SCR
        CALL    DOWNLOAD_COL

        LDA     #10000000B
        STA     2000H
        STA     RG2000

        LDA     #00011110B
        STA     2001H
        STA     RG2001

        LDA     #0
        STA     SCROLL_X
        STA     SCROLL_Y
        STA     VBLANK_FLAG

        CALL    INIT_SPRITE

?MAIN_LOOP
        CALL    MAIN_PROGRAM
        CALL    WAIT_VBLANK
        JMP     ?MAIN_LOOP
;=================================
; SUB:
;=================================
MAIN_PROGRAM

        CALL    SPR_PLAY

        ;

        DEC     SCROLL_X
        LDA     SCROLL_X
        CMP     #-1
        JR      NZ,?L1

        LDA     RG2000
        XOR     #01B
        STA     RG2000
?L1
        LDA     VBLANK_CNT
        LSR     A
        LSR     A
        AND     #31
        TAX
        LDA     ?Y_TAB,X
        STA     SCROLL_Y
?L2

        ; WATCH SYSTEM LOAD

        ;LDA     #11111110B
        ;STA     2001H

        RET
;---------------------------------
?Y_TAB
 DB 0
 DB 0
 DB 1
 DB 1
 DB 2
 DB 2
 DB 3
 DB 4
 DB 5
 DB 6
 DB 6
 DB 7
 DB 7
 DB 8
 DB 8
 DB 8
 DB 8
 DB 8
 DB 7
 DB 7
 DB 6
 DB 6
 DB 5
 DB 4
 DB 3
 DB 2
 DB 2
 DB 1
 DB 1
 DB 0
 DB 0
 DB 0
;=================================
; SUB:
;=================================
WAIT_VBLANK
        LDA     #0
        STA     VBLANK_FLAG
?L1
        LDA     VBLANK_FLAG
        JR      Z,?L1
        RET
;=================================
; SUB:
;=================================
NMI_ENTER:

        PUSH    A
        TXA
        PUSH    A
        TYA
        PUSH    A

        INC     VBLANK_FLAG
        INC     VBLANK_CNT

        LDA     RG2001
        STA     2001H
        LDA     RG2000
        STA     2000H

        LDA     SCROLL_X
        STA     2005H
        LDA     SCROLL_Y
        STA     2005H

        LDA     SPR_PAT_READY
        JR      Z,?L1

        CALL    SPR_PAT_DMA

        LDA     #0
        STA     2003H

        LDA     #2
        STA     4014H

        LDA     #0
        STA     SPR_PAT_READY
?L1


        LDA     2002H

        POP     A
        TAY
        POP     A
        TAX
        POP     A

        RETI
;=================================
; SUB:
;=================================
IRQ_SERVICE:
        RETI
;=================================
; SUB:
;=================================
DOWNLOAD_PAT

        LDA     #2
        STA     DMA_SRC_BANK
        LDA     #<8000H
        STA     DMA_SRC_LO
        LDA     #>8000H
        STA     DMA_SRC_HI

        LDA     #<8000H
        STA     DMA_DEST_LO
        LDA     #>8000H
        STA     DMA_DEST_HI

        LDA     #<7FFFH
        STA     DMA_LENG_LO
        LDA     #>7FFFH
        STA     DMA_LENG_HI

        LDA     #DMA_VRAM
        STA     DMA_STATUS

?W1
        LDA     DMA_STATUS
        AND     #DMA_ENABLE
        JR      NZ,?W1

        RET
;=================================
; SUB:
;=================================
DOWNLOAD_SCR

        LDA     #0
        STA     DMA_SRC_BANK
        LDA     #<BG_SCR
        STA     DMA_SRC_LO
        LDA     #>BG_SCR
        STA     DMA_SRC_HI

        LDA     #0
        STA     DMA_DEST_LO
        LDA     #0
        STA     DMA_DEST_HI

        LDA     #<2000H
        STA     DMA_LENG_LO
        LDA     #>2000H
        STA     DMA_LENG_HI

        LDA     #DMA_VRAM
        STA     DMA_STATUS

?W1
        LDA     DMA_STATUS
        AND     #DMA_ENABLE
        JR      NZ,?W1

        RET
;=================================
; SUB:
;=================================
DOWNLOAD_COL

        LDX     #0
?L1
        LDA     BG_COL,X
        STA     2040H,X

        INX
        CPX     #16
        JR      NZ,?L1
?L2
        LDA     S1_COL,X
        STA     2040H,X

        INX
        CPX     #32
        JR      NZ,?L2

        RET
;=================================
; SUB:
;=================================
INIT_SPRITE

        LDA_W#  SPR_ACTION_PTR,_ACTION
        LDA_RY  SPR_ACTION_PTR,#6
        STA     SPR_DELAY
        LDA_RY  SPR_ACTION_PTR,#7
        STA     SPR_DELAYH

        LDA     #0
        STA     SPR_X
        STA     SPR_Y
        STA     SPR_PAT_READY

        LDA     #100
        STA     SPR_YH
        STA     SPR_XH

        RET
;=================================
; SUB:
;=================================
SPR_PLAY

        ;

        CALL    CLEAR_ALL_SPRITE

        LDA_RY  SPR_ACTION_PTR,#0
        STA     R0
        LDA_RY  SPR_ACTION_PTR,#1
        STA     R0H

        LDX     SPR_XH
        LDY     SPR_YH

        CALL    SEND_SPR

        ; MOVE

        LDA_RY  SPR_ACTION_PTR,#2
        STA     R0
        LDA_RY  SPR_ACTION_PTR,#3
        STA     R0H
        REG_REG_ADD16 SPR_X,R0

        LDA_RY  SPR_ACTION_PTR,#4
        STA     R0
        LDA_RY  SPR_ACTION_PTR,#5
        STA     R0H
        REG_REG_ADD16 SPR_Y,R0

        ; NEXT STEP

        LDA     SPR_DELAY
        OR      SPR_DELAYH
        JR      NZ,?L1

        REG_ADD SPR_ACTION_PTR,#8

        LDA_RY  SPR_ACTION_PTR,#0
        STA     R0
        LDA_RY  SPR_ACTION_PTR,#1
        AND     R0
        CMP     #-1
        JR      NZ,?L3

        LDA_W#  SPR_ACTION_PTR,_ACTION
?L3
        LDA_RY  SPR_ACTION_PTR,#6
        STA     SPR_DELAY
        LDA_RY  SPR_ACTION_PTR,#7
        STA     SPR_DELAYH
        JMP     ?L2
?L1
        REG_DEC SPR_DELAY
?L2
        RET
;=================================
; SUB:
;   R0
;   X,Y
;
;   ?SPR_X,?SPR_Y
;=================================
SEND_SPR
;---------------------------------
?SPR_X          EQU     40H
?SPR_XP         EQU     41H
?SPR_Y          EQU     42H
?SPR_YP         EQU     43H
?WW             EQU     44H
?HH             EQU     45H
?W_CNT          EQU     46H
?H_CNT          EQU     47H
?C_X            EQU     48H
?C_Y            EQU     49H
?SPR_CHAR_CNT   EQU     4AH
?SPAT_PTR       EQU     4BH
?SPAT_PTRH      EQU     4CH
;---------------------------------

        STX     ?SPR_X
        STY     ?SPR_Y

        ; SPR_X,Y
        ; R0 = DATA PTR

        LDA_W#  ?SPAT_PTR,SPR_PAT_BUFF

        LDA     #0
        STA     ?SPR_CHAR_CNT

        LDA_RY  R0,#0
        STA     ?WW
        STA     ?W_CNT
        LDA_RY  R0,#1
        STA     ?HH
        STA     ?H_CNT
        LDA_RY  R0,#2
        NEG_A
        STA     ?C_X
        LDA_RY  R0,#3
        NEG_A
        STA     ?C_Y

        ;

        LDA     ?SPR_X
        CLC
        ADC     ?C_X
        STA     ?SPR_XP

        LDA     ?SPR_Y
        CLC
        ADC     ?C_Y
        STA     ?SPR_YP

        ;

        REG_ADD R0,#4
?LOOP
        LDA_RY  R0,#0
        STA     R1
        LDA_RY  R0,#1
        STA     R1H

        CALL    ?CPY_A_PAT
        CALL    ?WRITE_SPR_CHAR

        ; NEXT CHAR

        REG_ADD R0,#2

        LDA     ?SPR_XP
        CLC
        ADC     #8
        STA     ?SPR_XP

        DEC     ?W_CNT
        JR      NZ,?LOOP

        ; NEXT LINE

        DEC     ?H_CNT
        JR      Z,?END

        LDA     ?SPR_X
        CLC
        ADC     ?C_X
        STA     ?SPR_XP

        LDA     ?SPR_YP
        CLC
        ADC     #8
        STA     ?SPR_YP

        LDA     ?WW
        STA     ?W_CNT

        JMP     ?LOOP
?END
        LDA     #1
        STA     SPR_PAT_READY

        RET
;=================================
; SUB:
;  IN: R1 = PAT NUM
;      ?SPAT_PTR
;  TEMP USE = R5
;=================================
?CPY_A_PAT

 IF 1 ; USE DMA

        REG_REG R5,R1
        REG_ASL R5
        REG_ASL R5
        REG_ASL R5
        REG_ASL R5

        LDA     #1
        STA     DMA_SRC_BANK
        LDA     R5
        STA     DMA_SRC_LO
        LDA     R5H
        OR      #80H
        STA     DMA_SRC_HI

        LDA     ?SPAT_PTR
        STA     DMA_DEST_LO
        LDA     ?SPAT_PTRH
        STA     DMA_DEST_HI

        LDA     #15
        STA     DMA_LENG_LO
        LDA     #0
        STA     DMA_LENG_HI

        LDA     #DMA_MEMCPY
        STA     DMA_STATUS
?W1
        LDA     DMA_STATUS
        AND     #DMA_ENABLE
        JR      NZ,?W1

        REG_ADD ?SPAT_PTR,#16

 ELSE  ; USE COPY

        ; R1 = 0213

        REG_REG R5,R1
        REG_ASL R5
        REG_ASL R5
        REG_ASL R5
        REG_ASL R5

        ; R5 = 2130

        LDA     R1H
        AND     #7
        OR      #1*8 ; BANK 1
        STA     4040H

        LDA     R5H
        AND     #00FH
        OR      #080H
        STA     R5H

        LDY     #0
?L1
        LDA     (R5),Y
        STA     (?SPAT_PTR),Y
        INY
        CPY     #16
        JR      NZ,?L1

        LDA     #0
        STA     4040H

        REG_ADD ?SPAT_PTR,#16

 ENDIF

        RET
;=================================
; SUB:
;  IN: R1 = PAT NUM
;      ?SPR_CHAR_CNT
;=================================
?WRITE_SPR_CHAR

        LDA     ?SPR_CHAR_CNT
        ASL     A
        ASL     A
        TAX

        LDA     ?SPR_YP
        STA     200H,X

        LDA     ?SPR_CHAR_CNT
        STA     201H,X

        LDA     R1H
        LSR     A
        LSR     A
        LSR     A
        LSR     A
        AND     #11B
        STA     202H,X

        LDA     ?SPR_XP
        STA     203H,X

        INC     ?SPR_CHAR_CNT

        RET
;=================================
; SUB:
;=================================
CLEAR_ALL_SPRITE

        LDX     #00H
        LDA     #-8
?L2
        STA     200H,X
        INX
        JR      NZ,?L2

        RET
;=================================
; SUB:
;=================================
SPR_PAT_DMA

        LDA     #0
        STA     DMA_SRC_BANK
        LDA     #<SPR_PAT_BUFF
        STA     DMA_SRC_LO
        LDA     #>SPR_PAT_BUFF
        STA     DMA_SRC_HI

        LDA     #<2000H
        STA     DMA_DEST_LO
        LDA     #>2000H
        STA     DMA_DEST_HI

        LDA     #<3FFH
        STA     DMA_LENG_LO
        LDA     #>3FFH
        STA     DMA_LENG_HI

        LDA     #DMA_VRAM
        STA     DMA_STATUS
?W1
        LDA     DMA_STATUS
        AND     #DMA_ENABLE
        JR      NZ,?W1

        RET
;---------------------------------
;---------------------------------
        INCLUDE DATA\COL.H
        INCLUDE DATA\BG-SCR.H
        INCLUDE DATA\BG-COL.H
        INCLUDE DATA\S1.H
;---------------------------------
        ORG     FFFAH
;---------------------------------
 DW     NMI_ENTER       ; NMI
 DW     POWER_ON        ; RESET
 DW     IRQ_SERVICE     ; IRQ
;---------------------------------
        END
