 COMMENT * -------------------------

    IRQ & NMI & RESET

 ----------------------------------*
        INCLUDE MUSIC.H
        INCLUDE MUSIC.DAT
        INCLUDE ATLON_1.FCM
        INCLUDE ATLON_2.FCM
;---------------------------------
        EXTERN  INIT_MUSIC
        EXTERN  PLAY_MUSIC
        EXTERN  PLAY_SOUND_EFFECT
        EXTERN  STOP_MUSIC
        EXTERN  STOP_MUSIC2

;---------------------------------
        PUBLIC  NMI_ENTER
        PUBLIC  POWER_ON
        PUBLIC  IRQ_SERVICE
;---------------------------------
IRQ_SERVICE
        RETI
;---------------------------------
NMI_ENTER:
        PHA
        TXA
        PHA
        TYA
        PHA
        JSR     PLAY_SOUND_EFFECT
        JSR     PLAY_MUSIC
        PLA
        TAY
        PLA
        TAX
        PLA
        RETI
;---------------------------------
;=================================
; SUB:
;=================================
POWER_ON

        LDA     #0
        STA     2000H
        STA     2001H
        STA     4015H
        STA     4017H
        LDA     #80H                    ;Open NMI
        STA     2000H

;SET ALL CHANNELS OFF
        LDA     #$FF
        STA     SOUND_EFFECT1
        STA     SOUND_EFFECT2
        STA     SOUND_EFFECT3
        STA     SOUND_EFFECT4
        LDA     #00
        STA     EFFECT_CHANNEL
        STA     MUSIC_CHANNEL
        STA     SECOND_MUSIC_CHANNEL

;-----------------------------------------
;HOW TO INITIAL MUSIC DATA
;-----------------------------------------
        LDA     #1
        STA     MUSIC_NO
        LDA     #0
        STA     SECOND_MUSIC_SWITCH     ;=00H, SET THE 1'ST MUSIC ENABLE
        JSR     INIT_MUSIC

        LDA     #05H                    ;SET DELAY TIME
        JSR     DELAY

;-----------------------------------------
;HOW TO INSERT THE 2'ND MUSIC DATA
;-----------------------------------------
        LDA     #2                      ;MusicNo
        STA     MUSIC_NO
        LDA     #1
        STA     SECOND_MUSIC_SWITCH     ;=00H, SET THE 1'ST MUSIC ENABLE
        JSR     INIT_MUSIC              ;=01H, SET THE 2'ND MUSIC ENABLE

        LDA     #03H                    ;SET DELAY TIME
        JSR     DELAY

;---------------------------------
;HOW TO STOP MUSIC2
;---------------------------------

        JSR     STOP_MUSIC2

        LDA     #05H                    ;SET DELAY TIME
        JSR     DELAY

;---------------------------------
;HOW TO STOP MUSIC
;---------------------------------

        JSR     STOP_MUSIC

        JMP     END
;-----------------------------------------
;HOW TO SET SOUND EFFECT ENABLE
;-----------------------------------------
?EFFECT0
        LDA     #0                      ;SoundEffect1No
        STA     SOUND_EFFECT1

?EFFECT1
        LDA     #4                      ;SoundEffect2No
        STA     SOUND_EFFECT2

?EFFECT2
        LDA     #0                      ;SoundEffect3No
        STA     SOUND_EFFECT3

?EFFECT3
        LDA     #3                      ;SoundEffect4No
        STA     SOUND_EFFECT4

        LDA     #0
        STA     EFFECT_CHANNEL
END
        INX
        JMP     END

        RET
;---------------------------------
;---------------------------------
;=================================
; SUB:
;=================================
DELAY
        STA     $0302
        LDA     #0
        STA     $0300
        STA     $0301
DELAY_LOOP
        INC     $0300
        LDA     $0300
        JR      NZ,DELAY_LOOP
        INC     $0301
        LDA     $0301
        JR      NZ,DELAY_LOOP
        DEC     $0302
        LDA     $0302
        JR      NZ,DELAY_LOOP
        RET
;---------------------------------
        END
