;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;                                    Title	NT6578 test with demo program
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;----------------------------------------------------------------------------
; Version	: V1.7
; File name	: NT6578.ASM
; Date		: Jan  16 ,1997
; Language	:  6502 ASSEMBLY
; Description	: This program is used for test IC function of NT6578, with a simple program
;		  example for who will use and programing on this IC.
;----------------------------------------------------------------------------

			.SYNTAX     6502
			.SYMBOLS
			.LINKLIST

NT6576Version		.equ	#243d

;TestChip			.equ	#243d

;TestPS2Mouse		.equ	#243d		; set this label for disable some test function for jump
							; to test the PS/2 Mouse communication directly.

;DemoVersion			.equ	#243d		; set this label for disable non-neccessaryed test routine
							; during demo mode.

;TestSprite8X16		.equ	#243d		; set this label for use the joystick to control the motion
							; of sprite dureing 8X16 sprite testing.
;NullTime			.equ	#10d

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;			Variable section on Zero page 
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ZeroPage		.Section	Page0, Ref_Only
;
IndexAddr		ds	1			; define 1 byte for low byte of indirect addressing index
IndexAddrH		ds	1			; define 1 byte for high byte of indirect addressing index
							; Note : combain IdexAddr with IndexAddrH for a
							;	 complete indirect address index.
PNTAddr		ds	1			; Low byte of start address for Cell data table.
PNTAddrH		ds	1			; High byte of start address for Cell data table.
MapAddr		ds	1			; Low byte of start address for Map data table.
MapAddrH		ds	1			; High byte of start address for Map data table.
CellColorAddr		ds	1			; Low byte of start address for Cell Color table.
CellColorAddrH	ds	1			; High byte of start address for Cell Color table.
PageBuffAddr		ds	1			; Low byte of start address for template Page buffer.
PageBuffAddrH	ds	1			; High byte of start address for template Page buffer.
IRQVector		ds	1			; Low byte of vector for Interrupt service routine.
IRQVectorH		ds	1			; High byte of vector for Interrupt service routine.
TimerVector		ds	1			; Low byte of vector for Timer Interrupt service routine.
TimerVectorH		ds	1			; High byte of vector for Timer Interrupt service routine.
PalleteAddr		ds	1			; Low byte of start address for template Pallete buffer.
PalleteAddrH		ds	1			; High byte of start address for template Pallete buffer.
SnapshotAddr		ds	1			; Low byte of start address for Snapshot Table.
SnashotAddrH		ds	1			; High byte of start address for Snapshot Table.
; ------
TempAddr		ds	1			; low byte of indirect addressing index for template.
TempAddrH		ds	1			; high byte of indirect addressing index for template.
TempA			ds	1			; template register for A register.
TempX			ds	1			; template register for X register.
TempY			ds	1			; template register for Y register.
IRQTemp		ds	1			; templete register for Interrupt Status.
; ------
TimerCounter		ds	1			; count register for extned System Timer .
TimerCounterH	ds	1			; count register for extned System Timer .
NMICounter		ds	1			; count register of each NMI for delay.
ScrollCounter		ds	1			; count register of each NMI for color scroll delay control.
Ext3Counter		ds	1			; count register for external Interrupt 3.
RowIndex		ds	1			; The row number for which cell row will be decoded
							; from map table.
ColumnIndex		ds	1			; The column number for which column will be decoded
							; in a row.
PageIndex		ds	1			; The page number for which page will be decoded from
							; map table.
PNTBuffIdx		ds	1			; Index of PNT buffer for which is the start address to
							; store the PNT data.
CellColorIdx		ds	1			; Index of Cell Color buffer for which is the start address
							; to store the Cell Color data.
; ------
SystemControlBuff	ds	1			; System Control register backup buffer.
VideoControlBuff	ds	1			; Video Control register backup buffer.
ColorSelectBuff	ds	1			; Color Select register backup buffer.
StrobeControlBuff	ds	1			; Strobe Control register backup buffer.
SystemIRQMaskBuff	ds	1			; System Interrupt Mask register backup buffer.
TimerControlBuff	ds	1			; System Timer Control register backup buffer.
PalleteMode		ds	1			; Fill Color Pallete mode control register.
PalleteNumber		ds	1			; Color Pallete number register for ASCII display.
EvenRow		ds	1			; flag byte for identify odd or even row.
PositionX		ds	1			; Background X axis position register.
PositionY		ds	1			; Background Y axis position register.
CurrentPage		ds	1			; recode current page number for scroll control.
SpriteChange		ds	1			; Sprite Change flag for DMA control in NMI routine.
KeyboardChange	ds	1			; Keyboard direction change flag.
DMAFlag		ds	1			; DMA enable control flag.
XOffsetEnable		ds	1			; X offset enable flag.
BGTesting		ds	1			; Backgroung testing flag for enable the special effect.
; ------
MouseExist		ds	1			; Mouse existing flag for Mouse was detected on the port
							; of Joystick 2.
PS2MouseExist	ds	1			; PS/2 Mouse existing flag for Mouse was detected on the
							; port of Keyboard connector.
MouseID		ds	1			; Mouse return ID register.
MouseData		ds	1			; Mouse data templete buffer.
MouseButton		ds	1			; Mouse data buffer for button status.
MouseX		ds	1			; Mouse data buffer for X axis offset status.
MouseY		ds	1			; Mouse data buffer for Y axis offset status.
MouseXBuff		ds	1			; Templete Mouse data buffer for X axis offset status.
MouseYBuff		ds	1			; Templete Mouse data buffer for Y axis offset status.
MouseDataChange	ds	1			; a flag for Recive new data from Mouse.
; ------
KeyboardExist		ds	1			; Keyboard existing flag for Keyboard was detected.
KeyboardCmd		ds	1			; Sending and reciving Keyboard Command flag.
KeyboardInterrupt	ds	1			; Keyboard Interrupt flag.
KeyboardData		ds	1			; data register of Keyboard data.
KeyboardIndicator	ds	1			; bakcup buffer of Keyboard indicator.
NumLockPress		ds	1			; NumLock key pressed flag.
CapsLockPress		ds	1			; CapsLock key pressed flag.
ShiftKeyPress		ds	1			; Shift key pressed flag even left or right Shift key.
CtrlKeyPress		ds	1			; Ctrl key pressed flag even left or right Ctrl key.
AltKeyPress		ds	1			; Alt key pressed flag even left or right Alt key.
; ------
XOffsetIndex		ds	1			; Offset index register during X axis offset display.
; ------
Joystick1Data		ds	1			; data register of Joystick 1 :
							;	D0 - Right direction key;
							;	D1 - Left direction key;
							;	D2 - Down direction key;
							;	D3 - Up direction key;
							;	D4 - Start key;
							;	D5 - Select key;
							;	D6 - Button B;
							;	D7 - Button A;
Joystick2Data		ds	1			; data register of Joystick 2 :
							;	D0 - Right direction key;
							;	D1 - Left direction key;
							;	D2 - Down direction key;
							;	D3 - Up direction key;
							;	D4 - Start key;
							;	D5 - Select key;
							;	D6 - Button B;
							;	D7 - Button A;
; ------
PCMLength		ds	4			; define long word buffer for data length of PCM data.
; ------
SnapshotID		ds	1
SpriteLength		ds	1			; Total sprite number for snapshot update process.
FirstSprite		ds	1			; First sprite number for snapshot update process.
OffsetX		ds	1			; current snapshot offset position on X axis.
OffsetY		ds	1			; current snapshot offset position on Y axis.
CurrentDelay		ds	1			; current delay time of snapshot.
CurrentAction		ds	1			; current action number of snapshot.
ActionDX		ds	1			; new dX.
ActionDY		ds	1			; new dY.
TotalAction		ds	1			; total action number of a actor.
;
			.Ends				; End of ZeroPage section.
;
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;			Template Buffer section
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
TempBuffer		.Section	Offset $0200h, Ref_Only
;
CellTempBuffer	.ds	32			; Define 32 bytes for start address of a Cell
							; template after pass 1 decode but before pass 2 decode.
CellCodeBuffer	.ds	16			; Define 16 bytes for Cell code template buffer, this code
							; will used for decode cell color after PNT decoder.
;
			.Ends				; End of Template Buffer section.

SpriteBuffer		.equ	$0300h		; Define 256 bytes for Sprite data template buffer befor
							; DMA transfer.
PageBuffer		.equ	$0400h		; Define 7KBytes($0400h~$1FFFh) of internal working
							; RAM for general use buffer.
PageBuffer2		.equ	$0500h		; Define 256Bytes($0500h~$05ffH) OF internal working
							; RAM for general use.
PageColorBuffer	.equ	PageBuffer+$3C0h	; offset #$3C0h for cell color table.

		ifdef	NT6576Version
WorkBuffer		.equ	$6000h		; Define 2 Kbytes($5000h~$57FFh) of internal working
							; RAM for working buffer.
ExternalBuffer		.equ	$7000h		; Define 8 Kbytes($6000h~$7FFFh) of external working
							; RAM for working buffer.
		else
WorkBuffer		.equ	$5000h		; Define 2 Kbytes($5000h~$57FFh) of internal working
							; RAM for working buffer.
ExternalBuffer		.equ	$6000h		; Define 8 Kbytes($6000h~$7FFFh) of external working
							; RAM for working buffer.
		endif
;
YDisaper		.equ	#248d			; Define disaper position of Y axis for disaper the non
							; displayed sprite to the non visiable position.
;
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;			I/O port addressdefine by include file
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
			include		\Personal\NT6578\Source~1\Config.inc
;
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;			Background graphics and Sprite data section
; file type description for related files as below:
; Background Picture data -
;	.CGB file > Binary code of Background picture data, non-used for source program;
;	.CGD file > ASCII  data of Background picture data, non-used for source program;
; PGT data -
;	.CBB file > Binary code of pattern data(PGT), used for link with exectuable .Tsk file;
;	.CBD file > ASCII data of pattern data(PGT), used for included within an source program;
; Cell data -
;	.CLB file > Binary code of Cell data(Cell), used for link with an executable .Tsk file;
;	.CLD file > ASCII data of Cell data(Cell), used for included within an source program;
; Map data -
;	.CMB file > Binary code of Map data, used for link with an executable .Tsk file;
;	.CMD file > ASCII data of Map data, used for included within an source program;
; Cell color data -
;	.CEB file > Binary code of Cell Color data, used for link with an executable .Tsk file;
;	.CED file > ASCII data of Cell Color data, used for included within an source program;
; Color Pallete data -
;	.CCB file > Binary code of Color Pallete data, used for link with an executable .Tsk file;
;	.CCD file > ASCII data of Color Pallete data, used for included within an source program;
; Snapshot data for Sprite-
;	.CPB file > Binary code of Snapshot data for sprite, used for link with an executable .Tsk file;
;	.CPD file > ASCII data of Snapshot data for sprite, used for included within an source program;
; Motion data for Sprite-
;	.COB file > Binary code of Motion data for Sprite, used for link with an executable .Tsk file;
;	.COD file > ASCII data of Motion data for Sprite, used for included within an source program;
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
GraphicCode		.Section	Offset 8000h
;
ASCII16PGT		include		\Personal\NT6578\Graphi~1\ASCII16.Pat
							; 16 X 16 Fonts for ASCII code.
ASCII8PGT		include		\Personal\NT6578\Graphi~1\ASCII8.Pat
							; 8 X 8 Fonts for ASCII code.
UMCLogo		include		\Personal\NT6578\Graphi~1\UMCLogo.Pat
							; UMC logo by 64 X 64 pixels.
BlankPage		include		\Personal\NT6578\Graphi~1\Blank.Pnt
							; 1 page blank PNT data for initial Text Page display.
ASCII4Color		include		\Personal\NT6578\Graphi~1\ASCColor.Pal
							; Color pallete for 8 X 8 or 16 X 16 fonts ASCII code.
GirlColor		include		\Personal\NT6578\Graphi~1\D5.PAL
							; Color Pallete data file
SnapshotTable		include		\Personal\NT6578\Graphi~1\Sprite.PNT
							; Snapshot data
UMCLogoSprite	include		\Personal\NT6578\Graphi~1\UMCLogo.PNT
							; Snapshot data for UMC logo.
Sprite8X16		include		\Personal\NT6578\Graphi~1\Sprite16.Pnt
							; Snapshot data for UMC logo.
ColorBarPGT		include		\Personal\NT6578\Graphi~1\ASCColor.Pat
							; Color Bar PGT data.
ColorBarPNT		include		\Personal\NT6578\Graphi~1\ASCColor.Pnt
							; Color Bar PNT data.
BlankSprite		include		\Personal\NT6578\Graphi~1\BlankDIO.Pnt
							; Balnk sprite PNT data for clear sprite buffer.
ColorBarString		include		\Personal\NT6578\Graphi~1\ColorBar.Pnt
							; Sprite PNT data for Color Bar display string.
XOffsetTable		include		\Personal\NT6578\Source~1\XOffset.inc
							; X offset data table.
StandardASC		include		\Personal\NT6578\Source~1\BaseASC.inc
							; Base case ASCII code mapping table.
ShiftCaseASC		include		\Personal\NT6578\Source~1\UpperASC.inc
							; Shift case ASCII code mapping table.
CtrlCaseASC		include		\Personal\NT6578\Source~1\CtrlASC.inc
							; Ctrl case ASCII code mapping table.
NumLockASC		include		\Personal\NT6578\Source~1\NumASC.inc
							; NumLock case ASCII code mapping table.
CapsLockASC		include		\Personal\NT6578\Source~1\CapsASC.inc
							; CapsLock case ASCII code mapping table.
;
ColorBarPGTLength	.equ	ColorBarPNT-ColorBarPGT

ASCII16Length	.equ	(ASCII8PGT-ASCII16PGT).shr.4

UMCLogoOffset	.equ	((UMCLogo-ASCII16PGT)-$1000h).shr.4

ASCII8Length		.equ	UMCLogo-ASCII8PGT
;
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;	Program ROM Memory Mapping of NT6578 Demo Program
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;	00000-07FFF	Bank 0	|	0000-7FFF	: Main program
;	08000-0FFFF	Bank 1	|	0000-7FFF	: 1000 PGTs for 4 Pages display.
;	10000-13FFF	Bank 2 |	0000-3FFF	: 4 pages PNT data.
;	14000-17FFF	Bank 2 |	4000-7FFF	: Reseved.
;	18000-1CFFF	Bank 3 |	0000-4FFF	: Voice data of "The answer is"
;	1D000-1FFFF	Bank 3 |	5000-7FFF	: Voice data of "Very Good"
;	20000-27FFF	Bank 4 |	0000-7FFF	: waveform data for 5 seconds music, total 4 banks.
;	28000-2FFFF	Bank 5 |	"	"		"
;	30000-37FFF	Bank 6 |	"	"		"
;	38000-3FFFF	Bank 7 |	"	"		"
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;			Program code section for bank 0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Code			.Section	Stacked
;=====================================================================
;	Timer interrupt service routine
;=====================================================================
;
Reset:
			sei				; disable Timer interrupt
			cld				; disable Decimal operation
			ldx	#$FFh			; preset 256 bytes as stack buffer on
			txs				; $0100h~$01FFh to stack pointer
			ldx	#02h			; setup X register as loop counter for following wait loop
							; which will waiting 2 times of Vertical Blank circle for
WaitInitial:						; system initialize and stable.

			bit	PPUStatus		; waiting D7 of NMI flag goes High.
			bpl	WaitInitial

	?WaitLow:
			bit	PPUStatus		; waiting for D7 of NMI flag clear.
			bmi	?WaitLow

			dex
			bne	WaitInitial

			lda	#65h
			ldx	#76h
			sta	$4031h
			stx	$4031h

			lda	#10000000b		; set special code into DMA enable control register for 
			sta	SpecialControl		; enable the special DMA function.

			lda	#FFh
			sta	SystemIRQMask	; disable all of the system interrupt include Keyboard,
							; mouse, timer, printer etc.

			lda	#00000000b		; inhibit keyboard daata transfer and set communication
			sta	KeyboardControl	; as Keyboard to NT6578 as default.

			lda	#10001000b		; preset System Control register to initial state, include
			sta	SystemControl		;	- enable NMI during Vertical Blanking;
							;	- set 8 X 8 pixels for each pattern;
							;	- select page 0 as background graphics;
							;	- set Bank 0($0000h~$0FFFh) of PGT RAM for
							;	  Background PGT data;
							;	- set Bank 1($1000h~$1FFFh) of PGT RAM for
							;	  Sprite PGT data;

			lda	#00000110b		; preset Color Control register ot initial state, include
			sta	VideoControl		;	- set horizontal resulotion as 256 pixels;
							;	- disable all background and sprite display;
							;	- Enable all ehance effect of R.G.B. output;

			lda	#00000000b		; preset the Mouse Control port for select Joystick on
			sta	MouseControl		; the Port 2.

			lda	#00000010b		; Set Mouse Reset to high.
			sta	ExternalIO

			jsr	ClearWorkRAM	; call clear working RAM subroutine for initial.

			ldy	#05h
			jsr	WaitNMI

			jsr	DMAPNT16		; call for clear PNT data in VRAM $0000~$1FFF.

			lda	#<PageBuffer
			sta	PalleteAddr
			lda	#>PageBuffer
			sta	PalleteAddrH

			lda	#04h
			sta	PalleteMode
			jsr	TransferColor		; call for clear Color Pallete.

InitialSystem:
			lda	#FFh
			sta	SystemIRQMaskBuff	; disable all of the system interrupt include Keyboard,
							; mouse, timer, printer etc.

			lda	#10001000b		; preset System Control register to initial state, include
			sta	SystemControlBuff	;	- enable NMI during Vertical Blanking;
							;	- set 8 X 8 pixels for each pattern;
							;	- select page 0 as background graphics;
							;	- set Bank 0($0000h~$0FFFh) of PGT RAM for
							;	  Background PGT data;
							;	- set Bank 1($1000h~$1FFFh) of PGT RAM for
							;	  Sprite PGT data;

			lda	#00000110b		; preset Color Control register ot initial state, include
			sta	VideoControlBuff	;	- set horizontal resulotion as 256 pixels;
							;	- disable all background and sprite display;
							;	- Enable all ehance effect of R.G.B. output;
			lda	#00h
			sta	StrobeControl		; disable all I/O strobe signal.
			sta	StrobeControlBuff
			sta	SpriteChange		; clear Sprite Change flag.
			sta	Joystick1Data
			sta	Joystick2Data
			sta	DMAFlag
			sta	ScrollCounter
			sta	NMICounter
			sta	MouseExist		; clear Mouse existing flag.
			sta	PS2MouseExist	; clear PS/2 Mouse existing flag.
			sta	KeyboardCmd		; clear Keyboard Command flag.
			sta	MouseID
			sta	MouseButton
			sta	MouseX
			sta	MouseY
			sta	Ext3Counter
			sta	BGTesting
			sta	SpriteLength
			sta	FirstSprite
			sta	XOffsetEnable
			sta	KeyboardIndicator
			sta	KeyboardExist
			sta	NumLockPress
			sta	CapsLockPress
			sta	ShiftKeyPress
			sta	CtrlKeyPress
			sta	AltKeyPress
			sta	XOffsetIndex

			lda	#128D			; set screen postion of (128, 128).
			sta	PositionX
			sta	PositionY
			sta	ScreenPosition		; preset screen display to X=0, Y=0.
			sta	ScreenPosition

			lda	SystemControlBuff	; get current status of System Control register.
			and	#11111011b		; set VRAM address counter to +1 mode.
			sta	SystemControl
			sta	SystemControlBuff	; get current status of System Control register.

			lda	VideoControlBuff	; get current  status of Video Control register.
			and	#11100111b		; disable Sprite and Background display function for ready
							; to transfer one page background data into VRAM.
			sta	VideoControl

			cli				; enable Interrupt function of 6502 for ready to start
							; execute the main program.
			lda	VideoControlBuff	; re-store original data of Video Control Register.
			ora	#00001000b		; turn On Background display.
			sta	VideoControlBuff

ShowNT6578Title:
			jsr	InitTextPage		; call for initial ASCII PGT into VRAM for text display.

			lda	#<TitleString
			sta	IndexAddr
			lda	#>TitleString
			sta	IndexAddrH

	?ShowTitleLoop:
			ldy	#00d

			lda	(IndexAddr),y		; get the parameter for string length.
			cmp	#FFh			; check and exit if the data of length equal to #FFh.
			beq	?ShowTitleOK
			tay				; else set length parameter to Y register.

			clc
			lda	IndexAddr		; calculate the real start address of display string for who
			adc	#01d			; will be displayed.
			sta	IndexAddr
			lda	IndexAddrH
			adc	#00d
			sta	IndexAddrH

			lda	(IndexAddr),y		; get the parameter of row number.
			sta	RowIndex
			iny
			lda	(IndexAddr),y		; get the parameter of column number.
			sta	ColumnIndex
			iny
			lda	(IndexAddr),y		; get the parameter of pallete number.
			sta	PalleteNumber
			iny

			jsr	ShowString16		; call for show initial string to screen by 16 X 16 fonts.

			clc
			tya
			adc	IndexAddr
			sta	IndexAddr
			lda	IndexAddrH
			adc	#00d
			sta	IndexAddrH

			jmp	?ShowTitleLoop	; go back to loop for display next string.

	?ShowTitleOK:
			lda	#<SpareBar
			sta	IndexAddr
			lda	#>SpareBar
			sta	IndexAddrH

			ldy	#33d

			lda	(IndexAddr),y		; get the parameter of row number.
			sta	RowIndex
			iny
			lda	(IndexAddr),y		; get the parameter of column number.
			sta	ColumnIndex
			iny
			lda	(IndexAddr),y		; get the parameter of pallete number.
			sta	PalleteNumber

			jsr	ShowString8		; call for show the spare bar

			jsr	InitialTest		; call for execute initial test and show the resoult.

;			ldy	#20d
;			jsr	WaitNMI
;			jmp	?ShowNT6578Title

;
;	?DMATest:
;			jsr	TestDMAMode2	; call for test DMA mode 2 who will use 2 cycle for transfer
;							; data from source to work RAM.
;	?TimerTest:
;			jsr	TestSystemTimer	; call for test System Timer.
;
;

MainLoop:
			lda	BGTesting
			bne	?MouseDMATest
			jmp	?JoystickProcess

	?MouseDMATest:
		ifdef TestPS2Mouse
			lda	#00h			; setup bank select of DMA source to Bank 1 for
			sta	DMASourceBank	; background PGT data.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#07h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $07FF + 1 = 0800h bytes.

			lda	#00h			; setup low byte address of DMA source and destination.
			sta	DMADestinationL
			lda	#20h
			sta	DMADestinationH

			lda	NMICounter
			and	#00000001b
			bne	?TransferGirl

			lda	#>BlankPage		; set high byte index of blank page PNT data.
			sta	DMASourceH
			lda	#<BlankPage		; set low byte index of blank page PNT data.
			sta	DMASourceL
			jmp	?EnableDMA

	?TransferGirl:
			lda	#>WorkBuffer		; set high byte of index of 1 KBytes buffer.
			sta	DMASourceH
			lda	#<WorkBuffer
			sta	DMASourceL

	?EnableDMA:
			lda	#11000000b		; enable DMA mode 2 for move background PNT data from
			sta	DMAControl		; $5000~$57FF of bank 0 to $0000~$2FFF of VRAM.
		endif

			jsr	ScrollColor

			lda	PS2MouseExist
			bne	?MouseProcess

			lda	MouseExist		; if Mouse existed then start the Mouse process,
			beq	?JoystickProcess	; else start the Joystick process.

	?MouseProcess:
			lda	MouseDataChange	; check mouse data was changed for new process?
			beq	?JoystickProcess	; if mouse data not ready then Joystick process.

		ifndef TestPS2Mouse
			lda	#00h
			sta	MouseDataChange

			lda	MouseButton		; check for any button was pressed?
			beq	?MouseButtonRelease

			and	#00100000b		; check for left button pressed?
			beq	?CheckRightButton

			lda	#C1h
			sta	DMASourceH
			bne	?SetDMAParameter

	?CheckRightButton:
			lda	#C2h
			sta	DMASourceH
			bne	?SetDMAParameter

	?MouseButtonRelease:
			lda	#C0h
			sta	DMASourceH

	?SetDMAParameter:
			lda	#00d
			sta	DMASourceL
			lda	#02h
			sta	DMASourceBank

			lda	#00h
			sta	DMADestinationL
			lda	#20h
			sta	DMADestinationH

			lda	#FFh
			sta	DMALengthL
			lda	#00h
			sta	DMALengthH

			lda	#11000000b
			sta	DMAControl
		endif

	?CalcMouseX:
			lda	MouseX
			sta	OffsetX
			lda	MouseY
			sta	OffsetY

			lda	#00h
			sta	FirstSprite
			lda	#16d
			sta	SpriteLength

			jsr	SnapshotUpdate

	?JoystickProcess:
			lda	Joystick1Data
			bne	?CheckButtonA

			jmp	?NonKeyPressed

	?CheckButtonA:
			asl	A
			bcc	?CheckButtonB

			pha

			pla

	?CheckButtonB:
			asl	A
			bcc	?CheckSelect

			pha

			lda	#03h			; setup bank select of DMA source to Bank 4 for
			sta	DMASourceBank	; 11KHz Voice data - "The answer is".
			lda	#00h
			sta	TempAddr
			lda	#80h
			sta	TempAddrH
			jsr	PlayPCM

			lda	#03h			; setup bank select of DMA source to Bank 4 for
			sta	DMASourceBank	; 11KHz Voice data - "very good".
			lda	#00h
			sta	TempAddr
			lda	#D0h
			sta	TempAddrH
			jsr	PlayPCM

			pla

	?CheckSelect:
			asl	A
			bcc	?CheckStart

			pha
			jsr	Show4PagesGraphic
			pla

	?CheckStart:
			asl	A
			bcc	?CheckUp

			jmp	InitialSystem		; go back to show the NT6578 title and restart program.

	?CheckUp:
			asl	A
			bcc	?CheckDown

			pha
			jsr	UpScrollBG
			pla

	?CheckDown:
			asl	A
			bcc	?CheckLeft

			pha
			jsr	DownScrollBG
			pla

	?CheckLeft:
			asl	A
			bcc	?CheckRight

			pha
			jsr	RightScrollBG
			pla

	?CheckRight:
			asl	A
			bcc	?NonKeyPressed

			pha
			jsr	LeftScrollBG
			pla

	?NonKeyPressed:

			lda	NMICounter

	?WaitNMIChange:
			cmp	NMICounter
			beq	?WaitNMIChange	; wait 1 NMI cycle for update Joystick data.

EndOfProgram:
			jmp	MainLoop
;
;=====================================================================
;	End of Main Program section
;=====================================================================
;
TopLine		.equ	$02h
TestTopLine		.equ	#11d
ButtonLine		.equ	30d-TestTopLine-1

TitleString:
	?StringLength0:
			db	?StringData0-?String0
	?String0:
			db	">>>", $FFh
	?StringData0:
			db	TopLine, 01d, 09d

	?StringLength1:
			db	?StringData1-?String1
	?String1:
			db	"NT6578", $FFh
	?StringData1:
			db	TopLine, 09d, 04d

	?StringLength2:
			db	?StringData2-?String2
	?String2:
			db	"<<<", $FFh
	?StringData2:
			db	TopLine, 23d, 09d

	?StringLength3:
			db	?StringData3-?String3
	?String3:
			db	"Education", $FFh
	?StringData3:
			db	TopLine+2, 06d, 01d

	?StringLength4:
			db	?StringData4-?String4
	?String4:
			db	"Computer", $FFh 
	?StringData4:
			db	TopLine+4, 07d, 02d

	?StringLength5:
			db	?StringData5-?String5
	?String5:
			db	"Module", $FFh
	?StringData5:
			db	TopLine+6, 09d, 13d

	?StringFinish:
			db	$FFh

SpareBar:
			db	"________________________________", $FFh
			db	TopLine+8, 00d, 06d

TestOK:
			db	": OK", $FFh
TestFail:
			db	":Fail", $FFh
;
;=====================================================================
;	Subroutine section for NT6578 service routine
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: InitialTest
;	Function		: Test all of the function within NT6578 and shown the resoult.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
InitialTest:
			lda	#<?InitialTestTitle
			sta	IndexAddr
			lda	#>?InitialTestTitle
			sta	IndexAddrH

			ldx	#00h

	?ShowTitleLoop:
			ldy	#00d

			lda	(IndexAddr),y		; get the parameter for string length.
			cmp	#FFh			; check and exit if the data of length equal to #FFh.
			bne	?ShowTestItem

			jmp	?InitialTestFinish

	?ShowTestItem:
			tay				; else set length parameter to Y register.

			clc
			lda	IndexAddr		; calculate the real start address of display string for who
			adc	#01d			; will be displayed.
			sta	IndexAddr
			lda	IndexAddrH
			adc	#00d
			sta	IndexAddrH

			lda	(IndexAddr),y		; get the parameter of row number.
			sta	RowIndex
			iny
			lda	(IndexAddr),y		; get the parameter of column number.
			sta	ColumnIndex
			iny
			lda	(IndexAddr),y		; get the parameter of pallete number.
			sta	PalleteNumber
			iny

		ifdef	DemoVersion
			cpx	#03d
			bcc	?SkipShowItem
		endif

			jsr	ShowString8		; call for show initial string to screen by 16 X 16 fonts.
			inc	RowIndex

	?SkipShowItem:
			lda	IndexAddr
			pha				; backup LSB of Index address.
			lda	IndexAddrH
			pha				; backup MSB of Index address.

			inx

		ifdef	DemoVersion

			cpx	#04d
			bcc	?CalcNextItem
			jmp	?TestItem4

		else
			cpx	#01d
			bne	?TestItem2
		endif

	?TestItem1:
		ifndef TestPS2Mouse
			jsr	TestWorkRAM1	; call for test work RAM area 1.
			inc	RowIndex
			jsr	TestWorkRAM2	; call for test work RAM area 2.
		endif
			jmp	?CalcNextItem

	?TestItem2:
			cpx	#02d
			bne	?TestItem3

		ifndef TestPS2Mouse
			jsr	TestExtendRAM	; call for test extend RAM.
		endif
			jmp	?CalcNextItem

	?TestItem3:
			cpx	#03d
			bne	?TestItem4

		ifndef TestPS2Mouse
			jsr	TestVRAM		; call for test extend VRAM.
		endif
			jmp	?CalcNextItem

	?TestItem4:
			cpx	#04d
			bne	?TestItem5

		ifndef TestPS2Mouse
			jsr	TestMouse		; call for detect the Mouse on the port of Joystick 2.
		endif
			jmp	?CalcNextItem

	?TestItem5:
			cpx	#05d
			bne	?TestItem6

          			jsr	DetectKeyboard		; call for detect the PC/AT 101 keys Keyboard.
			jmp	?CalcNextItem

	?TestItem6:
			cpx	#06d
			bne	?TestItem7

		ifndef TestPS2Mouse
         			jsr	TestDAC		; call for test the 8 Bits DAC.
		endif
			jmp	?CalcNextItem

	?TestItem7:
			cpx	#07d
			bne	?TestItem8

		ifndef TestPS2Mouse
         			jsr	TestSprite		; call for test the 8X8 and 8X16 Sprite display.
		endif
			jmp	?CalcNextItem

	?TestItem8:

	?CalcNextItem:
			pla
			sta	IndexAddrH
			pla
			sta	IndexAddr

			clc
			tya
			adc	IndexAddr
			sta	IndexAddr
			lda	IndexAddrH
			adc	#00d
			sta	IndexAddrH

			jmp	?ShowTitleLoop	; go back to loop for display next string.


	?InitialTestFinish:
		ifndef TestPS2Mouse
         			jsr	TestSprite		; call for test the 8X8 and 8X16 Sprite display.

			jsr	TestColorBar		; call for test the color bar display.
		endif

			lda	KeyboardExist
			beq	?GraphTest

			jsr	TestKeyboard		; call for test the 101 keys keyboard.

	?GraphTest:
			jsr	Show4PagesGraphic	; call for show the 4 pages 16 colors graphic.

			rts
;
	?InitialTestTitle:
			db	?RAMStringData0-?RAMString0
	?RAMString0:
			db	"Work RAM Test", $FFh, 
	?RAMStringData0:
			db	TestTopLine, 00d, 10d

			db	?RAMStringData1-?RAMString1
	?RAMString1:
			db	"Extend RAM Test", $FFh, 
	?RAMStringData1:
			db	TestTopLine+4, 00d, 10d

			db	?VRAMStringData-?VRAMString
	?VRAMString:
			db	"Extend VRAM Test", $FFh, 
	?VRAMStringData:
			db	TestTopLine+7, 00d, 10d

			db	?MouseStringData-?MouseString
	?MouseString:
			db	"Mouse Test", $FFh, 
	?MouseStringData:
		ifdef	DemoVersion
			db	TestTopLine+1, 08d, 10d
		else
			db	TestTopLine+10, 00d, 10d
		endif

			db	?KeyboardStringData-?KeyboardString
	?KeyboardString:
			db	"Keyboard Test", $FFh, 
	?KeyboardStringData:
		ifdef	DemoVersion
			db	TestTopLine+5, 08d, 10d
		else
			db	TestTopLine+14, 00d, 10d
		endif

			db	?PCMStringData-?PCMString
	?PCMString:
			db	"8Bits DAC Test", $FFh, 
	?PCMStringData:
		ifdef	DemoVersion
			db	TestTopLine+9, 08d, 10d
		else
			db	TestTopLine, 16d, 10d
		endif

	?InitialTestItemFinished:
			db	$FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: Show4PagesGraphic
;	Function		: Show 4 pages Graphic.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
Show4PagesGraphic:
			lda	VideoControlBuff
			and	#11100111b
			sta	VideoControl

			lda	#128D			; set screen postion of (128, 128).
			sta	PositionX
			sta	PositionY
			sta	ScreenPosition		; preset screen display to X=0, Y=0.
			sta	ScreenPosition
			sta	OffsetX
			sta	OffsetY

			lda	#10001000b		; set color mode as follow define :
			sta	ColorSelect		;	D7 = 1, 16 colors mode for scenery display;
			sta	ColorSelectBuff	;	D3, D2 = 1 0, set sprite PGT start from $2000h;
							;	D0 = 0, set scenery PGT start from $0000h;

			jsr	ClearPGT32		; call for clear 32 KBytes PGT data.
			jsr	ClearBGPNT		; call for clear 10 KBytes PNT data.

			jsr	InitBGPGT32		; call for initial PGT data for Background into VRAM
							; from $8000h~$FFFFh.
;			jsr	InitSpritePGT16	; call for initial 1 set of Sprite PGT data into VRAM
;							; from $2000h~$27FFh
			jsr	InitBGPNT16		; call for initial 4 pages PNT data into VRAM 
							; from $0000h~$1FFFh.
			jsr	InitBGColorPallete16	; call for initial Background Color Pallete.

			jsr	InitSpriteBuffer	; call for clear Sprite Buffer then transfer into PPU.
			jsr	InitSnapshot

			lda	PS2MouseExist
			bne	?SetupPS2Mouse

			lda	MouseExist
			bne	?ShowSprite
			beq	?ShowScreen

	?SetupPS2Mouse:
			lda	SystemIRQMaskBuff
			and	#11011111b		; enable Keyboard Interrupt and disable Mouse Interrupt
			ora	#01000000b		; for PS/2 Mouse Service.
			sta	SystemIRQMaskBuff
			sta	SystemIRQMask

			lda	#FFh
			sta	KeyboardCmd

			lda	#F4h			; send command #F4h for enable PS/2 Mouse.
			jsr	SendKeyboardCmd

			lda	#00h
			sta	KeyboardCmd

			lda	#10000000b		; enable keyboard input for PS/2 Mouse.
			sta	KeyboardControl

	?ShowSprite:
			lda	VideoControlBuff	; re-store original data of Video Control Register.
			ora	#00010000b		; turn On Sprite display.
			sta	VideoControlBuff

	?ShowScreen:
			jsr	ColorFadeIn		; call Color Fade in subroutine for turn on background.
			lda	#FFh
			sta	BGTesting

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ShowKeyboardString
;	Function		: Show title string for test the 101 keys keyboard.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ShowKeyboardString:
			lda	#<?KeyboardString
			sta	IndexAddr
			lda	#>?KeyboardString
			sta	IndexAddrH

			lda	#00d
			sta	PalleteNumber
			lda	#03d
			sta	ColumnIndex
			lda	#03d
			sta	RowIndex
			jsr	ShowString16		; call for display Title string.	

			inc	RowIndex
			inc	RowIndex

			lda	#<?UserMessage
			sta	IndexAddr
			lda	#>?UserMessage
			sta	IndexAddrH

			lda	#14d
			sta	PalleteNumber
			lda	#00d
			sta	ColumnIndex
			jsr	ShowString8		; call for display message string.	

			inc	RowIndex

			lda	#<?ExitMessage1
			sta	IndexAddr
			lda	#>?ExitMessage1
			sta	IndexAddrH

			lda	#?ExitMessageStart1
			sta	ColumnIndex
			jsr	ShowString8		; call for display ExitMessage1.

			lda	#<?ExitMessage2
			sta	IndexAddr
			lda	#>?ExitMessage2
			sta	IndexAddrH

			lda	#02d
			sta	PalleteNumber
			lda	#?ExitMessageStart2
			sta	ColumnIndex
			jsr	ShowString8		; call for display ExitMessage2.

			lda	#<?ExitMessage3
			sta	IndexAddr
			lda	#>?ExitMessage3
			sta	IndexAddrH

			lda	#14d
			sta	PalleteNumber
			lda	#?ExitMessageStart3
			sta	ColumnIndex
			jsr	ShowString8		; call for display ExitMessage3.

			lda	#<?ExitMessage4
			sta	IndexAddr
			lda	#>?ExitMessage4
			sta	IndexAddrH

			lda	#01d
			sta	PalleteNumber
			lda	#?ExitMessageStart4
			sta	ColumnIndex
			jsr	ShowString8		; call for display ExitMessage4.

			inc	RowIndex

			lda	#<?SpareBar
			sta	IndexAddr
			lda	#>?SpareBar
			sta	IndexAddrH

			lda	#06d
			sta	PalleteNumber
			lda	#00d
			sta	ColumnIndex
			jsr	ShowString8		; call for display ExitMessage4.

			rts
;
	?KeyboardString:
			db	"Keyboard Test", $FFh

	?UserMessage:
			db	"Press any key for show as below,", $FFh


	?ExitMessage1:
			db	"or Press", $FFh
	?ExitMessage2:
			db	"Ctrl-C", $FFh
	?ExitMessage3:
			db	"to", $FFh
	?ExitMessage4:
			db	"Exit", $FFh

	?SpareBar:
			db	"________________________________", $FFh
;
?ExitMessageStart1	.equ	#04d
?ExitMessageStart2	.equ	?ExitMessage2-?ExitMessage1+?ExitMessageStart1
?ExitMessageStart3	.equ	?ExitMessage3-?ExitMessage2+?ExitMessageStart2
?ExitMessageStart4	.equ	?ExitMessage4-?ExitMessage3+?ExitMessageStart3
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: KeyboardTimerService
;	Function		: Service routine for Keyboard Timer Interrupt.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
KeyboardTimerService:
			lda	TimerCounter		; check TimerCounter for 2 times Interrupt per service.
			and	#00000001b
			bne	?CursorBlanking

			lda	#"_"			; get "_" character for cursor blink function.
			bne	?ShowCursor

	?CursorBlanking:
			lda	#" "			; get " " character for cursor display.

	?ShowCursor:
			sta	PageBuffer

			inc	TimerCounter

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

			lda	#00h
			sta	PalleteNumber

			jsr	ShowString8

	?TimerServiceOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: BreakCodeCheck
;	Function		: Check make code of keyboard data for setup related control flag.
;	Input Parameter	: KeyboardData - The make code of keyboard input data.
;	Return Parameter	: ShiftKeyPress - set to 00h if left or right Shift key released.
;				  CtrlKeyPress - set to 00h if left or right Ctrl key released.
;-------------------------------------------------------------------------------------------------------------------------------------
;
BreakCodeCheck:
			lda	KeyboardData

	?LeftShiftBreak:
			cmp	#AAh			; break code of left Shift key.
			beq	?SetShiftBreak

	?RightShiftBreak:
			cmp	#B6h			; break code of right Shift key.
			bne	?CtrlBreak

	?SetShiftBreak:
			lda	#00h
			sta	ShiftKeyPress
			jmp	?BreakCodeCheckOK

	?CtrlBreak:
			cmp	#9Dh			; break code of Ctrl key.
			bne	?BreakCodeCheckOK

			lda	#00h
			sta	CtrlKeyPress

	?BreakCodeCheckOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: KeyboardControlCheck
;	Function		: Check make code of keyboard data for setup related control flag.
;	Input Parameter	: KeyboardData - The make code of keyboard input data.
;	Return Parameter	: NumLockPress - toggle between 00h or FFh, if NumLock key pressed.
;				  CapsLockPress - toggle between 00h or FFh, if CpasLock key pressed.
;				  ShiftKeyPress - set to FFh if left or right Shift key pressed.
;				  CtrlKeyPress - set to FFh if left or right Ctrl key pressed.
;-------------------------------------------------------------------------------------------------------------------------------------
;
KeyboardControlCheck:
			lda	KeyboardData		; re-get scan code from keyboard.

	?CapsLockCheck:
			cmp	#3Ah			; Is make code of Caps Lock?
			bne	?LeftShiftCheck

			lda	CapsLockPress
			eor	#FFh			; toggle the current status of CapsLock key.
			sta	CapsLockPress

			lda	KeyboardIndicator
			and	#00000100b
			eor	#00000100b
			tax
			lda	KeyboardIndicator
			and	#11111011b

			jmp	?SendLEDCommand

	?LeftShiftCheck:
			cmp	#2Ah			; Is make code of left Shift key?
			beq	?SetupShiftFlag

	?RightShiftCheck:
			cmp	#36h			; Is make code of right Shift key?
			bne	?CtrlCheck

	?SetupShiftFlag:
			lda	#FFh
			sta	ShiftKeyPress		; setup Ctrl key pressed flag.
			jmp	?SetControlOK

	?CtrlCheck:
			cmp	#1Dh			; Is make code of left or right Ctrl key?
			bne	?NumLockCheck

			lda	#FFh
			sta	CtrlKeyPress		; setup Ctrl key pressed flag.
			jmp	?SetControlOK

	?NumLockCheck:
			cmp	#45h			; Is make code of NumLock key?
			bne	?SetControlOK

			lda	NumLockPress
			eor	#FFh			; toggle the current status of NumLock key.
			sta	NumLockPress

			lda	KeyboardIndicator
			and	#00000010b			
			eor	#00000010b
			tax
			lda	KeyboardIndicator
			and	#11111101b

	?SendLEDCommand:
			stx	KeyboardIndicator
			ora	KeyboardIndicator	; toggle LED status of NumLock or CapsLock, then set into 
			sta	KeyboardIndicator	; backup buffer.

			lda	#<NormalTimerService
			sta	TimerVector		; set new Timer Interrupt Service routine for Keyboard.
			lda	#>NormalTimerService
			sta	TimerVectorH

			lda	#01101111b		; disable system timer for ready to send Keyboard
			sta	SystemTimerControl	; command.

			lda	#EDh			; send command #EDh for turn lights of LED.
			jsr	SendKeyboardCmd

			lda	KeyboardIndicator	; get current LED status from backup buffer.
			jsr	SendKeyboardCmd	; the 'NumLock' LED.

			lda	#<KeyboardTimerService
			sta	TimerVector		; setup new vector for Keyboard Timer Service routine.
			lda	#>KeyboardTimerService
			sta	TimerVectorH

			lda	#244d			; preset counter value for 0.5 Sec per interrupt.
			sta	SetTimerValue		; the formule as 64uS * 16 * 489 = 0.500736 Sec.
			lda	#00h
			sta	TimerCounter		; initial TimerCounter for cursor blanking control.
			lda	#11101111b		; re-enable system timer and set function as follow:
			sta	SystemTimerControl	;	- Autoload counter value for continues count.
							;	- Use H-Blank as clock source(15625 Hz).
	?SetControlOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: WaitKeyScanCode
;	Function		: Wait a Keyboard Interrupt occure for get 1 byte data into KeyboardData.
;	Input Parameter	: None.
;	Return Parameter	: KeyboardData - The ASCII code relate to keyboard input data after translate.
;-------------------------------------------------------------------------------------------------------------------------------------
;
WaitKeyScanCode:
			lda	#10000000b		; set communcation direction for get key data from
			sta	KeyboardControl	; Keyboard.

	?WaitKeyboardInterrupt:
			lda	KeyboardInterrupt	; check keyboard interrupt for wait to recive the extra code.
			beq	?WaitKeyboardInterrupt

			lda	#00h			; else clear keyboard interrupt flag.
			sta	KeyboardInterrupt

	?WaitKeyScanOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ScanCode2ASCII
;	Function		: Translate Keyboard scan code data to ASCII code.
;	Input Parameter	: KeyboardData - The input data from Keyboard.
;	Return Parameter	: KeyboardData - The ASCII code relate to keyboard input data after translate.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ScanCode2ASCII:
			lda	KeyboardData
			cmp	#E1h			; check for start byte of Pause key?
			beq	?PauseKeyReading	; if same then goto read more data for Pause key.

			cmp	#E0h			; check for start byte of extra code?
			beq	?ExtraCodeProcess	; if the data is extra code then goto wait extra code.

	?CheckBreakCode:
			cmp	#80h			; check for break code?
			bcs	?SetBreakCode	; if the data is break code then got set break code.
			jmp	?TransferToASC	; else goto normal ASCII translate process.

	?ExtraCodeProcess:
			jsr	WaitKeyScanCode	; wait for 1 more byte of scan code from keyboard.

			lda	KeyboardData
			cmp	#38h			; check for right Alt key?
			beq	?TransferToASC	; if same then goto transfer to ASCII code.

			cmp	#1Dh			; check for right Ctrl key?
			beq	?TransferToASC	; if same then goto transfer to ASCII code.

			cmp	#1Ch			; check for Enter key on keypad?
			beq	?TransferToASC	; if same then goto transfer to ASCII code.

			cmp	#B8h			; check for break code of right Alt key?
			beq	?SetBreakCode	; if same then goto transfer to ASCII code.

			cmp	#9Dh			; check for break code of right Ctrl key?
			beq	?SetBreakCode	; if same then goto transfer to ASCII code.

	?NullCodeProcess:				; skip keyboard translate due to Insert, Delete, Home, End,
			lda	#00h			; PgUp and PgDn etc.
			sta	KeyboardData
			jmp	?ScanCode2ASCOK

	?PauseKeyReading:
			ldx	#05h			; setup X register to read 5 more code for a Pause key.

	?WaitMoreCode:
			jsr	WaitKeyScanCode	; wait for 1 more byte of scan code from keyboard.

			dex
			bne	?WaitMoreCode
			beq	?NullCodeProcess

	?SetControlFlag:
			jsr	KeyboardControlCheck
			jmp	?NullCodeProcess

	?SetBreakCode:
			jsr	BreakCodeCheck
			jmp	?NullCodeProcess

	?TransferToASC:
			and	#7Fh			; disable D7 for index to ASCII code table.
			tax				; set current keyboard data as index on X register.

	?CheckShiftPressed:
			lda	ShiftKeyPress		; Is Shift key press?
			beq	?CheckCtrlPressed

			lda	ShiftCaseASC,x	; get the related ASCII code with Shift Case status.
			cmp	#41h			; Is character ASCII code?
			bcc	?CheckControlKey

			cmp	#5Bh
			bcs	?CheckControlKey

			ldy	CapsLockPress		; Is Ctrl key press?
			beq	?CheckControlKey
			bne	?StandardCase

	?CheckCtrlPressed:
			lda	CtrlKeyPress		; Is Ctrl key press?
			beq	?CheckCapsLock

			lda	CtrlCaseASC,x		; get the related ASCII code with NumLock status.
			bne	?CheckControlKey

	?CheckCapsLock:
			lda	CapsLockPress		; Is Ctrl key press?
			beq	?StandardCase

			lda	CapsLockASC,x	; get the related ASCII code with NumLock status.
			bne	?CheckControlKey

	?StandardCase:
			lda	StandardASC,x	; get the related ASCII code with NumLock status.

	?CheckControlKey:
			cmp	#-1d			; does code same as control code?
			beq	?SetControlFlag	; if same then goto setup related flag.

			sta	KeyboardData

			cmp	#-2d
			bne	?ScanCode2ASCOK

			lda	NumLockPress		; Is NumLock key was pressed?
			beq	?ScanCode2ASCOK

			lda	NumLockASC,x	; get the related ASCII code with NumLock status.
			sta	KeyboardData

	?ScanCode2ASCOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestKeyboard
;	Function		: Test the key press function of 101 keys keyboard.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestKeyboard:
			txa
			pha
			tya
			pha

			jsr	ClearTextPage		; call for clear PNT data for 4 colors text page.

			lda	#FFh
			sta	KeyboardCmd

			lda	#EDh			; send command #EDh for turn lights of LED.
			jsr	SendKeyboardCmd

			lda	KeyboardIndicator	; get current LED status from backup buffer.
			jsr	SendKeyboardCmd	; the 'NumLock' LED.

			lda	#00D			; set screen postion of (0, 0).
			sta	PositionX
			sta	PositionY
			sta	ScreenPosition		; preset screen display to X=0, Y=0.
			sta	ScreenPosition

			jsr	ShowKeyboardString	; call for show the title of TestKeyboard.

			inc	RowIndex
			inc	RowIndex

			lda	#00h
			sta	ColumnIndex

			lda	#FFh
			sta	PageBuffer+1
			sta	PageBuffer2+1

			lda	TimerVector
			sta	TempAddr		; backup the original vector for Timer Interrupt.
			lda	TimerVectorH
			sta	TempAddrH

			lda	#<KeyboardTimerService
			sta	TimerVector		; setup new vector for Keyboard Timer Service routine.
			lda	#>KeyboardTimerService
			sta	TimerVectorH

			lda	#01011111b		; enable Timer Interrupt and Keyboard Interrupt.
			and	SystemIRQMaskBuff
			sta	SystemIRQMaskBuff
			sta	SystemIRQMask

			lda	#244d			; preset counter value for 0.5 Sec per interrupt.
			sta	SetTimerValue		; the formule as 64uS * 16 * 489 = 0.500736 Sec.

			lda	#00h
			sta	TimerCounter		; initial TimerCounter for cursor blanking control.
			sta	KeyboardInterrupt	; inital Keyboard Interrupt flag for ready to recive.

	?KeyboardPressLoop:
			lda	#11101111b		; enable system timer and set function as follow:
			sta	SystemTimerControl	;	- Autoload counter value for continues count.
							;	- Use H-Blank as clock source(15625 Hz).
	?WaitNewKey:
			jsr	WaitKeyScanCode	; wait for 1 byte of scan code from keyboard.

			jsr	ScanCode2ASCII	; and translate Key data to ASCII code.

			lda	KeyboardData
			beq	?WaitNewKey

			cmp	#03d			; Ctrl-C Pressed?
			beq	?TestKeyboardFinished

	?ShowASCIICode:
			sta	PageBuffer2		; set current ASCII code for display.

			lda	#01101111b		; disable System Timer during display ASCII code
			sta	SystemTimerControl

			lda	#<PageBuffer2
			sta	IndexAddr
			lda	#>PageBuffer2
			sta	IndexAddrH

			lda	#08d
			sta	PalleteNumber
			jsr	ShowString8		; call for display Title string.	

			inc	ColumnIndex
			lda	ColumnIndex
			cmp	#32d
			bne	?KeyboardPressLoop

			lda	#00d
			sta	ColumnIndex
			inc	RowIndex
			lda	RowIndex
			cmp	#?KeyPadButtonLine
			bne	?KeyboardPressLoop

			lda	#?KeyPadTopLine
			sta	RowIndex
			jmp	?KeyboardPressLoop

	?TestKeyboardFinished:
			lda	SystemTimerControl	; disable System Timer.
			and	#01111111b
			sta	SystemTimerControl

			lda	SystemIRQMaskBuff
			ora	#10100000b
			sta	SystemIRQMaskBuff
			sta	SystemIRQMask

			lda	TempAddr
			sta	TimerVector		; restore original vector.
			lda	TempAddrH
			sta	TimerVectorH

			lda	#00h
			sta	KeyboardCmd

			pla
			tay
			pla
			tax

			rts
;
?KeyPadTopLine	.equ	#09d			; top line number of keyboard display area.
?KeyPadButtonLine	.equ	#28d			; button line number of keyboard display area.
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestColorBar
;	Function		: Test the Color bar display by 16 colors background.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestColorBar:
			txa
			pha
			tya
			pha

			jsr	ClearTextPage		; call for clear PNT data for 4 colors text page.

			jsr	ClearSpriteBuffer	; call for clear sprite data in sprite buffer.

			lda	#00h			; setup bank select of DMA source to Bank 0 for
			sta	DMASourceBank	; ASCII 16 X 16 and 8 X 8 fonts PGT data.

			lda	#47d
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#00d			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $00FF + 1 = 0100h bytes.

			lda	#<SpriteBuffer		; setup destination address to $2000h of VRAM for DMA.
			sta	DMADestinationL
			lda	#>SpriteBuffer
			sta	DMADestinationH

			lda	#>ColorBarString	; set high byte index of Page Buffer for one page PNT data.
			sta	DMASourceH
			lda	#<ColorBarString	; set low byte index of Page Buffer for one page PNT data.
			sta	DMASourceL

			lda	#11100000b		; enable DMA mode 3 for move Sprite data of UMC logo
			sta	DMAControl		; from bank 0 to $2000~$27FF of VRAM for initial text
							; page.
			ldy	#01h
			jsr	WaitNMI		; waiting 1 NMI for DMA sprite data into sprite buffer.

			lda	#128d
			sta	OffsetX		; preset (128, 0) as original position for sprite.
			lda	#24d
			sta	OffsetY

			ldx	#00h
			ldy	#00h

	?SetSpritePGTLoop:
			lda	SpriteBuffer,x
			clc
			adc	OffsetY
			sta	SpriteBuffer,x		; calculate the related Y position.
			inx

			lda	SpriteBuffer,x
			clc
			adc	#<ASCII16Length	; add PGT offset into sprite PGT for get real PGT address.
			sta	SpriteBuffer,x
			inx
			inx

			lda	SpriteBuffer,x
			clc
			adc	OffsetX		; calculate the related X position.
			sta	SpriteBuffer,x
			inx
			iny
			cpy	#12d
			bne	?SetSpritePGTLoop

			lda	#FFh
			sta	SpriteChange

			ldy	#01h
			jsr	WaitNMI		; waiting 1 NMI for DMA sprite data into sprite buffer.

			lda	ColorSelectBuff
			and	#11110011b
			ora	#10000100b		; set sprite PGT bank change to $1XXX in VRAM.
			sta	ColorSelect		; and enable 16 colors mode for show the color bar.

			lda	VideoControlBuff
			ora	#00010000b		; enable sprite display for show the test title.
			sta	VideoControl

			lda	#00D			; set screen postion of (0, 0).
			sta	PositionX
			sta	PositionY
			sta	ScreenPosition		; preset screen display to X=0, Y=0.
			sta	ScreenPosition

	?MoveColorBarPGT:
			lda	#00h			; setup bank select of DMA source to Bank 0 for
			sta	DMASourceBank	; ASCII 16 X 16 and 8 X 8 fonts PGT data.

			lda	#<ColorBarPGTLength
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#>ColorBarPGTLength; setup high byte of DMA length.
			sta	DMALengthH

			lda	#00h			; setup destination address to $8000h of VRAM for DMA.
			sta	DMADestinationL
			lda	#80h
			sta	DMADestinationH

			lda	#>ColorBarPGT	; set high byte index of Page Buffer for one page PNT data.
			sta	DMASourceH
			lda	#<ColorBarPGT	; set low byte index of Page Buffer for one page PNT data.
			sta	DMASourceL

			lda	#11000000b		; enable DMA mode 2 for move blank page PNT data
			sta	DMAControl		; from bank 0 to $2000~$27FF of VRAM for initial text
							; page.
			ldy	#01
			jsr	WaitNMI

	?MoveColorBarPNT:
			lda	#00h			; setup bank select of DMA source to Bank 0 for
			sta	DMASourceBank	; ASCII 16 X 16 and 8 X 8 fonts PGT data.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#07h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $07FF + 1 = 0800h bytes.

			lda	#00h			; setup destination address to $2000h of VRAM for DMA.
			sta	DMADestinationL
			lda	#20h
			sta	DMADestinationH

			lda	#>ColorBarPNT	; set high byte index of Page Buffer for one page PNT data.
			sta	DMASourceH
			lda	#<ColorBarPNT	; set low byte index of Page Buffer for one page PNT data.
			sta	DMASourceL

			lda	#11000000b		; enable DMA mode 2 for move blank page PNT data
			sta	DMAControl		; from bank 0 to $2000~$27FF of VRAM for initial text
							; page.
			ldy	#128d
			jsr	WaitNMI

			lda	PositionX
			sta	TempA			; backup screen position
			lda	PositionY
			sta	TempY

			lda	TimerVector
			sta	IndexAddr		; backup the original vector for Timer Interrupt.
			lda	TimerVectorH
			sta	IndexAddrH

			lda	#<XOffsetService	; set X offset service routine as new Timer Interrupt service
			sta	TimerVector		; routine.
			lda	#>XOffsetService
			sta	TimerVectorH

			lda	#01111111b		; enable Timer Interrupt.
			and	SystemIRQMaskBuff
			sta	SystemIRQMaskBuff
			sta	SystemIRQMask

			lda	#00h
			sta	SetTimerValue		; setup timer value to 0 for generator interrupt during each
							; Horizontal balnk.
			lda	#FFh
			sta	XOffsetEnable		; enable the special effect of X offset.

			ldy	#255d
			jsr	WaitNMI

			lda	#00h
			sta	XOffsetEnable		; enable the special effect of X offset.

			lda	TempA
			sta	PositionX		; restore original screen position
			sta	ScreenPosition
			lda	TempY
			sta	PositionY
			sta	ScreenPosition

			lda	TimerControlBuff	; restore the original Interrupt control register.
			sta	SystemTimerControl

			lda	IndexAddr
			sta	TimerVector		; restore the original vector for Timer Interrupt service
			lda	IndexAddrH		; routine
			sta	TimerVectorH

			lda	ColorSelectBuff	; restore the original status of color mode select register.
			sta	ColorSelect

			lda	VideoControlBuff	; restore original display status.
			sta	VideoControl

	?TestColorBarOK:
			pla
			tay
			pla
			tax

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ClearSpriteBuffer
;	Function		: Clear Sprite buffer for remove sprite display.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ClearSpriteBuffer:
			lda	#00h			; setup bank select of DMA source to Bank 0 for
			sta	DMASourceBank	; ASCII 16 X 16 and 8 X 8 fonts PGT data.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#00h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $00FF + 1 = 0100h bytes.

			lda	#<SpriteBuffer		; setup destination address to $2000h of VRAM for DMA.
			sta	DMADestinationL
			lda	#>SpriteBuffer
			sta	DMADestinationH

			lda	#>BlankSprite		; set high byte index of Page Buffer for one page PNT data.
			sta	DMASourceH
			lda	#<BlankSprite		; set low byte index of Page Buffer for one page PNT data.
			sta	DMASourceL

			lda	#11100000b		; enable DMA mode 3 for move Sprite data of UMC logo
			sta	DMAControl		; from bank 0 to $2000~$27FF of VRAM for initial text
							; page.
			ldy	#01h
			jsr	WaitNMI

			lda	#FFh
			sta	SpriteChange

			ldy	#01h
			jsr	WaitNMI

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: Test8X8Sprite
;	Function		: Test the 8X8 sprite display.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
Test8X8Sprite:
			lda	#<?8X8Sprite
			sta	IndexAddr
			lda	#>?8X8Sprite
			sta	IndexAddrH

			lda	#10d
			sta	PalleteNumber
			lda	#08d
			sta	ColumnIndex
			jsr	ShowString8		; call for display resoult string.

			lda	#00h			; setup bank select of DMA source to Bank 0 for
			sta	DMASourceBank	; ASCII 16 X 16 and 8 X 8 fonts PGT data.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#00h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $00FF + 1 = 0100h bytes.

			lda	#<SpriteBuffer		; setup destination address to $2000h of VRAM for DMA.
			sta	DMADestinationL
			lda	#>SpriteBuffer
			sta	DMADestinationH

			lda	#>UMCLogoSprite	; set high byte index of Page Buffer for one page PNT data.
			sta	DMASourceH
			lda	#<UMCLogoSprite	; set low byte index of Page Buffer for one page PNT data.
			sta	DMASourceL

			lda	#11100000b		; enable DMA mode 3 for move Sprite data of UMC logo
			sta	DMAControl		; from bank 0 to $2000~$27FF of VRAM for initial text
							; page.
			ldy	#01h
			jsr	WaitNMI		; waiting 1 NMI for DMA sprite data into sprite buffer.

			lda	#180d
			sta	OffsetX		; preset (128, 128) as original position for sprite.
			sta	OffsetY

			ldx	#00h
			ldy	#00h

	?SetSpritePGTLoop:
			lda	SpriteBuffer,x
			clc
			adc	OffsetY
			sta	SpriteBuffer,x		; calculate the related Y position.
			inx

			lda	SpriteBuffer,x
			clc
			adc	#<UMCLogoOffset	; add PGT offset into sprite PGT for get real PGT address.
			sta	SpriteBuffer,x
			inx
			inx

			lda	SpriteBuffer,x
			clc
			adc	OffsetX		; calculate the related X position.
			sta	SpriteBuffer,x
			inx
			iny
			cpy	#64d
			bne	?SetSpritePGTLoop

			lda	#FFh
			sta	SpriteChange

			ldy	#01h
			jsr	WaitNMI		; waiting 1 NMI for DMA sprite data into sprite buffer.

			lda	ColorSelectBuff
			and	#11110011b
			ora	#00000100b		; set sprite PGT bank change to $1XXX in VRAM.
			sta	ColorSelect

			lda	VideoControlBuff
			ora	#00010000b
			sta	VideoControl

			ldx	#120d
			lda	#00h
			sta	FirstSprite

			lda	#-1d
			sta	OffsetX
			sta	OffsetY

	?LeftUpMove:
			lda	#64d
			sta	SpriteLength

			jsr	SnapshotUpdate

			ldy	#01h
			jsr	WaitNMI

			dex
			bne	?LeftUpMove

			ldx	#120d
			lda	#+1d
			sta	OffsetX
			sta	OffsetY

	?RightDownMove:
			lda	#64d
			sta	SpriteLength

			jsr	SnapshotUpdate

			ldy	#01h
			jsr	WaitNMI

			dex
			bne	?RightDownMove

			ldy	#60d
			jsr	WaitNMI		; waiting 10 NMI for hold the display.

			rts
;
	?8X8Sprite:
			db	" 8X8 Sprite Test", $FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: Test8X16Sprite
;	Function		: Test the 8X16 sprite display.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
Test8X16Sprite:
			jsr	ClearTextPage		; call for clear PNT data for 4 colors text page.

			lda	#<?8X16Sprite
			sta	IndexAddr
			lda	#>?8X16Sprite
			sta	IndexAddrH

			lda	#10d
			sta	PalleteNumber
			lda	#08d
			sta	ColumnIndex
			jsr	ShowString8		; call for display resoult string.

			lda	#00h			; setup bank select of DMA source to Bank 0 for
			sta	DMASourceBank	; ASCII 16 X 16 and 8 X 8 fonts PGT data.

			lda	#<ASCII8Length
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#>ASCII8Length	; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $00FF + 1 = 0100h bytes.

			lda	#E0h			; setup destination address to $07E0h of VRAM for mirror
			sta	DMADestinationL	; PGT data during 8X16 sprite display.
			lda	#07h
			sta	DMADestinationH

			lda	#>ASCII8PGT		; set high byte index of Page Buffer for one page PNT data.
			sta	DMASourceH
			lda	#<ASCII8PGT		; set low byte index of Page Buffer for one page PNT data.
			sta	DMASourceL

			lda	#11000000b		; enable DMA mode 2 for move 8X8 font PGT data
			sta	DMAControl		; from bank 0 to $07E0~$0DD0 of VRAM.

			ldy	#01h
			jsr	WaitNMI		; waiting 1 NMI for DMA sprite data into sprite buffer.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#00h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $00FF + 1 = 0100h bytes.

			lda	#<SpriteBuffer		; setup destination address to $2000h of VRAM for DMA.
			sta	DMADestinationL
			lda	#>SpriteBuffer
			sta	DMADestinationH

			lda	#>Sprite8X16		; set high byte index of Page Buffer for one page PNT data.
			sta	DMASourceH
			lda	#<Sprite8X16		; set low byte index of Page Buffer for one page PNT data.
			sta	DMASourceL

			lda	#11100000b		; enable DMA mode 3 for move Sprite data of UMC logo
			sta	DMAControl		; from bank 0 to Sprite buffer.

			ldy	#01h
			jsr	WaitNMI		; waiting 1 NMI for DMA sprite data into sprite buffer.

			lda	#151d
			sta	OffsetX		; preset (128, 128) as original position for sprite.
			sta	OffsetY

			ldx	#00h
			ldy	#00h

	?SetSprite16PGTLoop:
			lda	SpriteBuffer,x
			clc
			adc	OffsetY
			sta	SpriteBuffer,x		; calculate the related Y position.
			inx

			lda	SpriteBuffer,x
			clc
			adc	#<ASCII16Length	; add PGT offset into sprite PGT for get real PGT address.
			sta	SpriteBuffer,x
			inx
			inx

			lda	SpriteBuffer,x
			clc
			adc	OffsetX		; calculate the related X position.
			sta	SpriteBuffer,x
			inx
			iny
			cpy	#64d
			bne	?SetSprite16PGTLoop

			lda	#FFh
			sta	SpriteChange

			ldy	#01h
			jsr	WaitNMI		; waiting 1 NMI for DMA sprite data into sprite buffer.

			lda	SystemControlBuff
			ora	#00100000b
			sta	SystemControl

			ldx	#70d
			lda	#00h
			sta	FirstSprite

		ifdef	TestSprite8X16

	?SpriteMotion:
			lda	#00d
			sta	OffsetX
			sta	OffsetY

			lda	Joystick1Data
			beq	?UpdateMotion

	?CheckButtonA:
			asl	A
			bcc	?CheckButtonB

			jmp	?Test8X16SpriteOK

	?CheckButtonB:
			asl	A		; button B
			asl	A		; Select
			asl	A		; Start

	?CheckUp:
			asl	A
			bcc	?CheckDown

			pha
			lda	#00d
			sta	OffsetX
			lda	#-1d
			sta	OffsetY
			pla

	?CheckDown:
			asl	A
			bcc	?CheckLeft

			pha
			lda	#00d
			sta	OffsetX
			lda	#+1d
			sta	OffsetY
			pla

	?CheckLeft:
			asl	A
			bcc	?CheckRight

			pha
			lda	#-1d
			sta	OffsetX
			lda	#00d
			sta	OffsetY
			pla

	?CheckRight:
			asl	A
			bcc	?UpdateMotion

			pha
			lda	#+1d
			sta	OffsetX
			lda	#00d
			sta	OffsetY
			pla

	?UpdateMotion:
			lda	#64d
			sta	SpriteLength

			jsr	SnapshotUpdate

			ldy	#01d
			jsr	WaitNMI

			jmp	?SpriteMotion
		else
			lda	#-1d
			sta	OffsetX
			sta	OffsetY

	?LeftUpMove16:
			lda	#64d
			sta	SpriteLength

			jsr	SnapshotUpdate

			ldy	#2h
			jsr	WaitNMI

			dex
			bne	?LeftUpMove16

			ldx	#70d
			lda	#+1d
			sta	OffsetX
			sta	OffsetY

	?RightDownMove16:
			lda	#64d
			sta	SpriteLength

			jsr	SnapshotUpdate

			ldy	#02h
			jsr	WaitNMI

			dex
			bne	?RightDownMove16
		endif

	?Test8X16SpriteOK:
		ifndef	TestSprite8X16
			ldy	#60d
			jsr	WaitNMI		; waiting 60 NMI for hold the display.
		endif

			lda	SystemControlBuff
			sta	SystemControl

			jsr	InitTextPage		; re-initial Text Page.

			rts
;
	?8X16Sprite:
			db	" 8X16 Sprite", $FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestSprite
;	Function		: Test the 8X8 and 8X16 sprite display.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestSprite:
			txa
			pha
			tya
			pha

			jsr	ClearTextPage		; call for clear PNT data for 4 colors text page.

			lda	#<?SpriteString
			sta	IndexAddr
			lda	#>?SpriteString
			sta	IndexAddrH

			lda	#00d
			sta	PalleteNumber
			lda	#04d
			sta	ColumnIndex
			lda	#03d
			sta	RowIndex
			jsr	ShowString16		; call for display resoult string.	

			inc	RowIndex
			inc	RowIndex

			jsr	Test8X8Sprite		; call for test 8X8 fonts sprite.

			jsr	ClearTextPage		; call for clear PNT data for 4 colors text page.

		ifndef	DemoVersion
			lda	#<?SpriteString
			sta	IndexAddr
			lda	#>?SpriteString
			sta	IndexAddrH

			lda	#00d
			sta	PalleteNumber
			lda	#04d
			sta	ColumnIndex
			lda	#03d
			sta	RowIndex
			jsr	ShowString16		; call for display resoult string.	

			inc	RowIndex
			inc	RowIndex

			jsr	Test8X16Sprite
		endif

			lda	VideoControlBuff
			sta	VideoControl

			pla
			tay
			pla
			tax

			rts
;
	?SpriteString:
			db	"Sprite Test", $FFh, 
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestDAC
;	Function		: Test 8 Bits DAC with PCM play back.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestDAC:
			txa
			pha
			tya
			pha

			lda	#<?22KSample
			sta	IndexAddr
			lda	#>?22KSample
			sta	IndexAddrH

			lda	#00d
			sta	PalleteNumber

			jsr	ShowString8		; call for display resoult string.

			inc	RowIndex

			lda	#04h			; setup bank select of DMA source to Bank 4 for
			sta	DMASourceBank	; 22KHz Music data.
			lda	#00h
			sta	TempAddr
			lda	#80h
			sta	TempAddrH
			jsr	PlayPCM

		ifndef	TestChip
			lda	#04h			; setup bank select of DMA source to Bank 4 for
			sta	DMASourceBank	; 22KHz Music data.
			lda	#00h
			sta	TempAddr
			lda	#80h
			sta	TempAddrH
			jsr	PlayPCM
		endif

			ldy	#50d
			jsr	WaitNMI

			lda	#<?11KSample
			sta	IndexAddr
			lda	#>?11KSample
			sta	IndexAddrH

			lda	#00d
			sta	PalleteNumber

			jsr	ShowString8		; call for display resoult string.

			inc	RowIndex

			lda	#03h			; setup bank select of DMA source to Bank 4 for
			sta	DMASourceBank	; 11KHz Voice data - "The answer is".
			lda	#00h
			sta	TempAddr
			lda	#80h
			sta	TempAddrH
			jsr	PlayPCM

			lda	#03h			; setup bank select of DMA source to Bank 4 for
			sta	DMASourceBank	; 11KHz Voice data - "very good".
			lda	#00h
			sta	TempAddr
			lda	#D0h
			sta	TempAddrH
			jsr	PlayPCM

			pla
			tay
			pla
			tax

			rts
;
	?22KSample:
			db	"22KHz Music", $FFh
	?11KSample:
			db	"11KHz Voice", $FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ShowString8
;	Function		: Display specified string into page 5 by 8 X 8 fonts during text mode,
;				  and the start position specified by ColumnIndex and RowIndex.
;	Input Parameter	: IndexAddr - Low byte index address of display string.
;				  IndexAddrH - High byte index address of display string.
;				  ColumnIndex - Start pisition of X axis for display string.
;				  RowIndex - Start pisition of Y axis for display string.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ShowString8:
			pha
			txa
			pha
			tya
			pha

			jsr	CalcTextPNTAddr	; call for calculate start address  of PNT data.

			ldy	#00h			; initial Y register for index counter.

	?ShowStringLoop:
			lda	(IndexAddr),y
			cmp	#FFh			; check the display code for $FFh.
			beq	?FillStringFinished	; if display code same as $FFh then stop show loop.

			sta	TempA			; store ASCII code into TempA for display.
			jsr	Set8X8Fonts		; call subroutine for set 8 X 8 fonts PNT data into VRAM.

			iny
			bne	?ShowStringLoop

	?FillStringFinished:
			jsr	DMATextPNT		; call for transfer 1 page Text PNT into VRAM.

			pla
			tay
			pla
			tax
			pla
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: Set8X8Fonts
;	Function		: Set Display data into 4 colors text display with 8 X 8 fonts.
;	Input Parameter	: TempA - Contain the display data who will set into VRAM for display.
;				  PNTAddr - low byte index for start address of PNT.
;				  PNTAddrH - high byte index for start address of PNT.
;				  PalleteNumber - Control for which color pallete will used on the current font.
;	Return Parameter	: PNTAddr - low byte index for next PNT start address.
;				  PNTAddrH - high byte index for next PNT start address.
;-------------------------------------------------------------------------------------------------------------------------------------
;
Set8X8Fonts:
			txa
			pha
			tya
			pha

			lda	#00h
			sta	TempY			; initial TempY for MSB of PNT data.

			lda	TempA			; get standard ASCII code.
			sec
			sbc	#20h			; subtract #20h for cut the 32 symbols not included.
			clc
			adc	#<ASCII16Length	;  add an LSB of 16 bits offset for skip the area of 
			sta	TempX			; ASCII 16X16 fonts.
			lda	TempY
			adc	#>ASCII16Length	; add an MSB of 16 bits offset for skip the area of
			sta	TempY			; ASCII 16X16 fonts.

			jsr	GetTextColorPallete	; call for get the color pallete number into PNT data.

			ldy	#00h			; offset 0 PGTs for first line of 8 X 8 fonts.

			lda	TempX
			sta	(PNTAddr),y		; store LSB of PNT data first for PGT.
			iny
			lda	TempY
			sta	(PNTAddr),y		; then store MSB of PNT data.

			clc
			lda	PNTAddr
			adc	#02d			; offset 4 bytes for 2 PNT data on first and second lines.
			sta	PNTAddr
			lda	PNTAddrH
			adc	#00h
			sta	PNTAddrH

			pla
			tay
			pla
			tax

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: GetTextColorPallete
;	Function		: Transfe color pallete number into PNT data for text page display.
;	Input Parameter	: PalleteNumber - Control for which color pallete will used on the current font.
;				  TempY - MSB of PNT data.
;	Return Parameter	: TempY - MSB of PNT data with color pallete number.
;-------------------------------------------------------------------------------------------------------------------------------------
;
GetTextColorPallete:
			lda	PalleteNumber
			asl	A
			asl	A
			asl	A
			asl	A
			ora	TempY			; store pallete number into MSB for PNT data.
			sta	TempY

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: DMATextPNT
;	Function		: Enable DMA mode 2 for transfer Text page PNT data into $2000h of VRAM.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
DMATextPNT:
			lda	#00h			; setup bank select of DMA source to Bank 0 for
			sta	DMASourceBank	; ASCII 16 X 16 and 8 X 8 fonts PGT data.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#07h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $07FF + 1 = 0800h bytes.

			lda	#00h			; setup destination address to $2000h of VRAM for DMA.
			sta	DMADestinationL
			lda	#20h
			sta	DMADestinationH

			lda	#>WorkBuffer		; set high byte index of Page Buffer for one page PNT data.
			sta	DMASourceH
			lda	#<WorkBuffer		; set low byte index of Page Buffer for one page PNT data.
			sta	DMASourceL

			lda	#11000000b		; enable DMA mode 2 for move blank page PNT data
			sta	DMAControl		; from bank 0 to $2000~$27FF of VRAM for initial text
							; page.
			ldy	#01
			jsr	WaitNMI

	?DMATextPNTOk:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: CalcTextPNTAddr
;	Function		: Calculate the real start address for PNT data.
;	Input Parameter	: ColumnIndex - Start pisition of X axis for display string.
;				  RowIndex - Start pisition of Y axis for display string.
;	Return Parameter	: PNTAddr - LSB of start address for PNT data.
;				  PNTAddrH - MSB of start address for PNT data.
;-------------------------------------------------------------------------------------------------------------------------------------
;
CalcTextPNTAddr:
			lda	#00h
			sta	PNTAddrH		; initial high byte PNT address  for MSB of PNT.
			lda	RowIndex		; get Row Index for calculate real address of PNT.
			and	#1Fh

			ldx	#06h

	?RowIndexX64:
			asl	A			; let Row Index left shift 6 times for multiplex by 64
			rol	PNTAddrH		; to calculate real PNT start address.
			dex
			bne	?RowIndexX64

			sta	PNTAddr		; store LSB of PNT address into PNTAddr.

			lda	ColumnIndex		; get Column Index and multiplex by 2 for calculate the 
			and	#1Fh			; real LSB address of PNT.
			asl	A
			ora	PNTAddr
			sta	PNTAddr		; set real start LSB address of PNT.

			lda	PNTAddrH
			clc
			adc	#>WorkBuffer		; offset $5000h bytes for start address of WorkBuffer.
			sta	PNTAddrH

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: Set16X16Fonts
;	Function		: Set Display data into 4 colors text display with 16 X 16 fonts.
;	Input Parameter	: TempA - Contain the display data who will set into VRAM for display.
;				  PNTAddr - low byte index for start address of PNT.
;				  PNTAddrH - high byte index for start address of PNT.
;				  PalleteNumber - Control for which color pallete will used on the current font.
;	Return Parameter	: PNTAddr - low byte index for next PNT start address.
;				  PNTAddrH - high byte index for next PNT start address.
;-------------------------------------------------------------------------------------------------------------------------------------
;
Set16X16Fonts:
			txa
			pha
			tya
			pha

			lda	#00h
			sta	TempY			; initial TempY for MSB of PNT data.

			lda	TempA			; get standard ASCII code.
			sec
			sbc	#20h			; subtract #20h for cut the 32 symbols not included.
			and	#11111000b		; get D3~D7 of MSB index from ASCII code.
			asl	A
			rol	TempY
			asl	A
			rol	TempY			; let MSB X 4 for MSB of PNT data and store into TempY.
			sta	TempX			; store LSB of PNT data into TempX

			lda	TempA
			and	#00000111b		; get D0~D2 of LSB index from ASCII code.
			asl	A
			ora	TempX			; let LSB X 2 for LSB of PNT data.
			sta	TempX	

			jsr	GetTextColorPallete	; call for get the color pallete number into PNT data.

			ldy	#00h			; offset 0 PGTs for first line of 16 X 16 fonts.

			lda	TempX
			sta	(PNTAddr),y		; store LSB of PNT data first for 1'st PGT.
			tax
			iny
			lda	TempY
			sta	(PNTAddr),y		; then store MSB of PNT data.
			iny

			inx
			txa				; let LSB index to next PGT for 16 X 16 fonts.
			sta	(PNTAddr),y
			iny
			lda	TempY
			sta	(PNTAddr),y		; store MSB of PNT data for 2'nd PGT.

			ldy	#64d			; offset 32 PGTs for second line of 16 X 16 fonts.
			lda	TempX
			clc
			adc	#10h			; let LSB offset 32 PGT for second line.
			sta	(PNTAddr),y
			tax
			iny
			lda	TempY
			sta	(PNTAddr),y		; store MSB of PNT data for 3'rd PGT.

			iny
			inx
			txa
			sta	(PNTAddr),y
			iny
			lda	TempY
			sta	(PNTAddr),y		; store MSB of PNT data for 4'th PGT.

			clc
			lda	PNTAddr
			adc	#04d			; offset 4 bytes for 2 PNT data on first and second lines.
			sta	PNTAddr
			lda	PNTAddrH
			adc	#00h
			sta	PNTAddrH

			pla
			tay
			pla
			tax

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ShowString16
;	Function		: Display specified string into page 5 by 16 X 16 fonts during text mode,
;				  and the start position specified by ColumnIndex and RowIndex.
;	Input Parameter	: IndexAddr - Low byte index address of display string.
;				  IndexAddrH - High byte index address of display string.
;				  ColumnIndex - Start pisition of X axis for display string.
;				  RowIndex - Start pisition of Y axis for display string.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ShowString16:
			pha
			txa
			pha
			tya
			pha

			jsr	CalcTextPNTAddr	; call for calculate start address  of PNT data.

			ldy	#00h			; initial Y register for index counter.

	?ShowStringLoop:
			lda	(IndexAddr),y
			cmp	#FFh			; check the display code for $FFh.
			beq	?FillStringFinished	; if display code same as $FFh then stop show loop.

			sta	TempA			; store ASCII code into TempA for display.
			jsr	Set16X16Fonts	; call subroutine for set 16 X 16 fonts PNT data into VRAM.

			iny
			bne	?ShowStringLoop

	?FillStringFinished:
			jsr	DMATextPNT		; call for transfer 1 page Text PNT into VRAM.

			pla
			tay
			pla
			tax
			pla
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ClearTextPage
;	Function		: Clear PNT data on $2000h~$27FFh of VRAM for clear 4 colors mode text page.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ClearTextPage:
			lda	#00h
			sta	DMASourceBank

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#07h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $07FF + 1 = 0800h bytes.

			lda	#>BlankPage		; set high byte index of blank page PNT data.
			sta	DMASourceH
			lda	#<BlankPage		; set low byte index of blank page PNT data.
			sta	DMASourceL

			lda	#<WorkBuffer		; setup destination address to $5000h of Working RAM.
			sta	DMADestinationL
			lda	#>WorkBuffer
			sta	DMADestinationH

			lda	#10100000b		; enable DMA mode 3 for move blank page PNT data
			sta	DMAControl		; from bank 0 to $0400~$13FF of Working RAM for
							; initial text page.
			ldy	#01h
			jsr	WaitNMI

			jsr	DMATextPNT		; call for move PNT data into VRAM.

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: InitTextPage
;	Function		: Initial PGT of ASCII 16 X 16 and 8 X 8 fonts into $0000h~$1FFFh of VRAM
;				  for 4 colors mode text display .
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
InitTextPage:
			lda	VideoControlBuff
			and	#11100111b
			sta	VideoControl

			lda	#00D			; set screen postion of (0, 0).
			sta	PositionX
			sta	PositionY
			sta	ScreenPosition		; preset screen display to X=0, Y=0.
			sta	ScreenPosition

			lda	#00001001b		; set color mode as follow define :
			sta	ColorSelect		;	D7 = 0, 4 colors mode for scenery display;
			sta	ColorSelectBuff	;	D3, D2 = 1 0, set sprite PGT start from $2000h;
							;	D0 = 1, set scenery PNT start from $2000h;

			lda	#00h			; setup bank select of DMA source to Bank 0 for
			sta	DMASourceBank	; ASCII 16 X 16 and 8 X 8 fonts PGT data.

	?Move16X16Fonts:
			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#1Fh			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $1FFF + 1 = 2000h bytes.

			lda	#00h			; setup destination address to $0000h of VRAM for DMA.
			sta	DMADestinationL
			sta	DMADestinationH

			lda	#>ASCII16PGT	; set high byte index of ASCII fonts PGT data.
			sta	DMASourceH
			lda	#<ASCII16PGT	; set low byte index of ASCII fonts PGT data.
			sta	DMASourceL

			lda	#11000000b		; enable DMA mode 2 for move ASCII fonts PGT data
			sta	DMAControl		;  from bank 0 to $0000~$1FFF of VRAM.

	?InitialPNT:
			ldy	#01h
			jsr	WaitNMI

			jsr	ClearTextPage		; call for clear PNT data of 4 colors text page.

	?Init4ColorsPallete:
			lda	#<ASCII4Color	; set highh byte index of blank page PNT data.
			sta	PalleteAddr
			lda	#>ASCII4Color	; set low byte index of blank page PNT data.
			sta	PalleteAddrH

			lda	#04h
			sta	PalleteMode
			jsr	TransferColor		; call for clear Color Pallete.

	?InitControlRegister:
			lda	VideoControlBuff
			ora	#00001000b
			sta 	VideoControl
			sta	VideoControlBuff

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: PlayPCM
;	Function		: Play PCM wave data by use the System Timer Interrupt, and follow the 
;				  wave file format by Microsoft Sound System version 1.0.
;	Input Parameter	: DMASourceBank - Source bank for the address of wave data who will be played
;						         by this subroutine.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
PlayPCM:
			lda	#01111111b		; enable Timer Interrupt only during play PCM.
			sta	SystemIRQMask

			lda	SystemControlBuff
			and	#011111111b		; disable NMI during paly PCM.
			sta	SystemControl

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#00h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $00FF + 1 = 0100h bytes.

			lda	TempAddr		; setup low byte address of DMA source and destination.
			sta	DMASourceL
			lda	TempAddrH		; setup high byte address of DMA source and destination.
			sta	DMASourceH

			lda	#<TempBuffer
			sta	DMADestinationL
			lda	#>TempBuffer
			sta	DMADestinationH

			lda	#11100000b		; enable DMA mode 0 for move background PGT data from
			sta	DMAControl		; $8000~$80FF of bank 4 to $0200~$02FF of work RAM.

			ldy	#28h			; set Y register as offset for PCM data length parameter.
			lda	TempBuffer,y
			clc
			adc	#01d
			sta	PCMLength		; set lowest byte of PCM data length.
			lda	TempBuffer+1,y
			clc
			adc	#01d
			sta	PCMLength+1		; set 2'nd byte of PCM data length.
			lda	TempBuffer+2,y
			clc
			adc	#01d
			sta	PCMLength+2		; set 3'rd byte of PCM data length.
			lda	TempBuffer+3,y
			clc
			adc	#01d
			sta	PCMLength+3		; set highest byte of PCM data length.

			ldy	#18h			; set Y register as offset for PCM sample rate parameter.
			lda	TempBuffer,y		; get PCM sample rate parameter into A register.

	?Check44K:
			cmp	#44h			; the sampling rate is 44.1KHz?
			bne	?Check22K
			lda	#40d			; set counter as 40d for 22.6uS per interrupt.
			bne	?SetCounter

	?Check22K:
			cmp	#22h			; the sampling rate is 22.05KHz?
			bne	?Check11K
			lda	#81d			; set counter as 81d for 45.3uS per interrupt.
			bne	?SetCounter

	?Check11K:
			cmp	#11h			; the sampling rate is 11KHz?
			bne	?Check8K
			lda	#162d			; set counter as 162d for 90.7uS per interrupt.
			bne	?SetCounter

	?Check8K:
			lda	#210d			; set counter as 224d for 125uS per interrupt.

	?SetCounter:
			sta	SetTimerValue		; setup Timer Counter for sampling rate control.

	?ReadyToPlay:
			lda	TempAddr
			clc
			adc	#2Ch
			tax				; set X as low byte index of PCM data start address.
			stx	DMASourceL
			lda	TempAddrH
;			adc	#00h
			tay				; set Y as high byte index of PCM data start address.
			sty	DMASourceH

			lda	#00h
			sta	DMALengthL		; setup DMA length for transfer 1 byte PCM data.
			sta	DMALengthH		; for total transfer length = $0000 + 1 = 0001h bytes.

			lda	#<PCMData
			sta	DMADestinationL
			lda	#>PCMData
			sta	DMADestinationH

			sei				; disable all of the System Interrupt for Play PCM,
							; the CPU must pooling the System Interrupt Ststus to get
							; the Interrupt Status for best performance can be up to
							; 44.1 KHz sample rate.
			lda	#11000000b	 	; setup System Timer Counter for 0.5uS per period.
			sta	SystemTimerControl	; then enable System Timer Counter.

	?WaitSamplePulse:
			lda	#00000000b

	?WaitSampling:
			ora	SystemIRQStatus
			beq	?WaitSampling

			lda	#11111111b
			sta	SystemIRQMask
			lda	#01111111b		; enable Timer Interrupt only during play PCM.
			sta	SystemIRQMask

	?TransferPCMData:
			lda	#11100000b		; enable DMA mode 0 for move 1 byte PCM data from
			sta	DMAControl		; PCM data bank to PCMData($4027h).

			inx				; increase low byte index of PCM data table
			stx	DMASourceL
			bne	?CalcDataLength	; if low byte was over count then increase high byte index.

			iny
			bne	?SetDMASourceH

			ldy	#80h			; if high byte index over count too, then increase the bank
			inc	DMASourceBank

	?SetDMASourceH:
			sty	DMASourceH

	?CalcDataLength:
			dec	PCMLength
			bne	?WaitSamplePulse

			dec	PCMLength+1
			bne	?WaitSamplePulse

			dec	PCMLength+2
			bne	?WaitSamplePulse

			dec	PCMLength+3
			bne	?WaitSamplePulse

			lda	#00000000b	 	; setup System Timer Counter for 0.5uS per period.
			sta	SystemTimerControl	; then enable System Timer Counter.

			lda	SystemIRQMaskBuff	; restore System IRQ Mask.
			sta	SystemIRQMask

			lda	SystemControlBuff
			ora	#10000000b		; enable NMI for wait i NMI cycle.
			sta	SystemControl

			ldy	#1d			; wait 1 NMI cycle for update the new status of Joystick.
			jsr	WaitNMI

			lda	SystemControlBuff	; restore System Control.
			sta	SystemControl

			cli

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: PS2MouseService
;	Function		: Read 3 bytes PS/2 mouse data from Keyboard Input port.
;	Input Parameter	: PS2MouseExist - PS/2 Mouse existing flag.
;					PS2MouseExist = 0, PS/2 Mouse did not exist on the Keyboard port.
;					PS2MouseExist = Non-Zero, Mouse existing on the Keyboard port.
;	Return Parameter	: MouseDataChange - Mouse data complete readed flag.
;					MouseDataChange = 0, not read 3 bytes data complete yet.
;					MouseDataChange = #FFh, read 3 bytes data completed.
;				  PS2MouseExist - PS/2 Mouse existing flag and Mouse data counter.
;					PS2MouseExist = 1~3, PS/2 Mouse exist flag and read data counter.
;-------------------------------------------------------------------------------------------------------------------------------------
;
PS2MouseService:
			lda	KeyboardDataIn
			sta	MouseData

			lda	PS2MouseExist	; check for Mouse exist already?
			beq	?MouseDataComplete	; if Mouse first time to detected, then goto setup data 
							; change flag for recive initial response from Mouse, 
							; else read 3 bytes data from Mouse for Mirosoft Mouse
							; format.
	?Read1stByte:
			cmp	#01d			; data counter = 1 st byte?
			bne	?Read2ndByte

			clc
			lda	MouseData
			and	#00000011b
			asl	A
			asl	A
			asl	A
			asl	A
			sta	MouseButton

			inc	PS2MouseExist
			bne	?MouseServiceOK

	?Read2ndByte:
			cmp	#02d			; data counter = 2nd byte?
			bne	?Read3rdByte

			lda	MouseData
			sta	MouseXBuff

			inc	PS2MouseExist
			bne	?MouseServiceOK

	?Read3rdByte:
			lda	MouseData
			eor	#11111111b
			sta	MouseY

			lda	MouseXBuff
			sta	MouseX

			lda	#01d
			sta	PS2MouseExist

	?MouseDataComplete:
			lda	#FFh
			sta	MouseDataChange

	?MouseServiceOK:
			lda	SystemIRQMaskBuff	; restore original System IRQ mask.
			sta	SystemIRQMask

			lda	#10000000b
			sta	KeyboardControl

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: MouseService
;	Function		: Read 3 bytes mouse data from Mouse Input port.
;	Input Parameter	: MouseExist - Mouse existing flag.
;					MouseExist = 0, Mouse did not exist on the port of Joystick 2.
;					MouseExist = Non-Zero, Mouse existing on the port of Joystick 2.
;	Return Parameter	: MouseDataChange - Mouse data complete readed flag.
;					MouseDataChange = 0, not read 3 bytes data complete yet.
;					MouseDataChange = #FFh, read 3 bytes data completed.
;				  MouseExist - Mouse existing flag and Mouse data counter.
;					MouseExist = 1~3, Mouse exist flag and read data counter.
;-------------------------------------------------------------------------------------------------------------------------------------
;
MouseService:
			lda	MouseDataIn
			eor	#FFh
			sta	MouseData

			lda	MouseExist		; check for Mouse exist already?
			beq	?MouseDataComplete	; if Mouse first time to detected, then goto setup data change
							; flag for recive initial response from Mouse, else read
							; 3 bytes data from Mouse for Mirosoft Mouse format.
	?Read1stByte:
			cmp	#01d			; data counter = 1 st byte?
			bne	?Read2ndByte

			lda	MouseData
			and	#00110000b
			sta	MouseButton

			clc
			lda	MouseData
			and	#00001100b
			asl	A
			asl	A
			asl	A
			asl	A
	 		sta	MouseYBuff

			clc
			lda	MouseData
			and	#00000011b
			ror	A
			ror	A
			ror	A
			sta	MouseXBuff

			inc	MouseExist
			bne	?MouseServiceOK

	?Read2ndByte:
			cmp	#02d			; data counter = 2nd byte?
			bne	?Read3rdByte

			lda	MouseData
			and	#00111111b		; get D5~D0 of X offset.
			ora	MouseXBuff
			sta	MouseXBuff

			inc	MouseExist
			bne	?MouseServiceOK

	?Read3rdByte:
			lda	MouseData
			and	#00111111b		; get D5~D0 of Y offset.
			ora	MouseYBuff
			sta	MouseY

			lda	MouseXBuff
			sta	MouseX

			lda	#01d
			sta	MouseExist

	?MouseDataComplete:
			lda	#FFh
			sta	MouseDataChange

	?MouseServiceOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestMouse
;	Function		: Test and detect does the Mouse exist.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestMouse:
			txa
			pha
			tya
			pha

			jsr	DetectMouse

			lda	MouseExist
			bne	?MouseExist

			lda	#<?MouseMissed
			sta	IndexAddr
			lda	#>?MouseMissed
			sta	IndexAddrH

			lda	#02d
			sta	PalleteNumber
			jmp	?ShowResoult

	?MouseExist:
			lda	#<?MouseDetected
			sta	IndexAddr
			lda	#>?MouseDetected
			sta	IndexAddrH

			lda	#01d
			sta	PalleteNumber

	?ShowResoult:
			jsr	ShowString8		; call for display resoult string.

			inc	RowIndex

			ldy	#00h

	?MoveString:
			lda	?MouseResponse,y	; move default string into buffer.
			sta	PageBuffer,y

			iny
			cmp	#FFh			; if not end of string then keep moving.
			bne	?MoveString			

			ldx	MouseID		; get return code rom mouse to X register.
			txa
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+13		; set to buffer as "$Nx00-$NxFF"

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+14		; set to buffer as "$xN00-$xNFF"

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

			lda	#00d
			sta	PalleteNumber

			jsr	ShowString8		; call for display resoult string.

	?TestMouseFinished:
			pla
			tay
			pla
			tax

			rts
;
	?MouseDetected:
			db	"Mouse detect", $FFh
	?MouseMissed:
			db	"Mouse missed", $FFh
	?MouseResponse:
			db	"Return Code:   ", $FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: DetectMouse
;	Function		: Detect for does the Mouse exist.
;	Input Parameter	: None.
;	Return Parameter	: MouseExist - Mouse existing flag.
;					MouseExist = 0, Mouse did not exist on the port of Joystick 2.
;					MouseExist = Non-Zero, The return code from Mouse.
;-------------------------------------------------------------------------------------------------------------------------------------
;
DetectMouse:
			lda	#00000001b		; set Mouse connected on the port 2.
			sta	MouseControl

			lda	#00h
			sta	MouseDataChange

			lda	#<NormalTimerService
			sta	TimerVector		; set new Timer Interrupt Service routine for Keyboard.
			lda	#>NormalTimerService
			sta	TimerVectorH

			ldy	#00h

			lda	SystemIRQMaskBuff
			and	#10011111b		; enable IRQ for Mouse.
			sta	SystemIRQMaskBuff
			sta	SystemIRQMask

			lda	ExternalIO		; reset Mouse for test mouse exist.
			and	#11111101b
			sta	ExternalIO

			lda	#01h
			sta	TimerCounter		; setup Timer Counter as flag for Timer Interrupt.

			lda	#30d			; setup Timer Interrupt as 30mS for reset mouse.
			jsr	SetupTimerValue

	?WaitReset:
			lda	TimerCounter		; check Timer Counter for Time-Out detection
			bne	?WaitReset

			lda	ExternalIO
			ora	#00000010b		; reset Mouse for test mouse exist.
			sta	ExternalIO

			lda	#01h
			sta	TimerCounter		; setup Timer Counter as flag for Timer Interrupt.

			lda	#30d			; setup Timer Interrupt as 30mS as response time for
			jsr	SetupTimerValue	; waiting the response from Mouse.

	?WaitResponse:
			lda	TimerCounter		; check Timer Counter for Time-Out detection
			beq	?SetMouseResult

			lda	MouseDataChange	; waiting for get return code from mouse.
			beq	?WaitResponse

	?WaitResponseOK:
			lda	MouseData		; if return code is #00h that mean no mouse connected
			beq	?SetMouseResult	; to NT6578.

			sta	MouseID
			lda	#01h

	?SetMouseResult:
			sta	MouseExist

			lda	#00h
			sta	MouseDataChange
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TimerVectorJump
;	Function		: Jump to Timer Interrupt Routine by jump vector of TimerVector.
;	Input Parameter	: TimerVector - Low byte vector of Timer Interrupt Service Routine.
;				  TimerVectorH - High byte vector of Time Interrupt Service Routine.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TimerVectorJump:
			jmp	(TimerVector)
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ClockTimerService
;	Function		: Service routine for Test Timer Interrupt.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ClockTimerService:
			lda	PalleteMode
			bne	?VTimerMode

			lda	TimerCounter		; check TimerCounter for 2 times Interrupt per service.
			and	#00000001b
			beq	?TimerServiceOK

			lda	PageBuffer+12		; get ":" character for blink function.
			eor	#00011010b
			sta	PageBuffer+12

			lda	TimerCounter
			cmp	#03h
			bcs	?DisplayResult

			lda	#FFh
			sta	TimerCounter
			bne	?ChangeValue

	?VTimerMode:
			lda	TimerCounter
			bne	?TimerServiceOK

			inc	TimerCounterH
			lda	TimerCounterH
			and	#00000001b
			beq	?TimerServiceOK

			lda	PageBuffer+12		; get ":" character for blink function.
			eor	#00011010b
			sta	PageBuffer+12

			lda	TimerCounterH
			cmp	#03h
			bcs	?DisplayResult

			lda	#FFh
			sta	TimerCounterH


	?ChangeValue:
			inc	TempX
			lda	TempX
			jsr	Msb2ASCII
			sta	PageBuffer+13

			lda	TempX
			jsr	Lsb2ASCII
			sta	PageBuffer+14

			lda	TempX
			bne	?DisplayResult

			inc	TempY
			lda	TempY
			jsr	Msb2ASCII
			sta	PageBuffer+10

			lda	TempY
			jsr	Lsb2ASCII
			sta	PageBuffer+11

	?DisplayResult:
			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

			lda	#00h
			sta	ColumnIndex

;			jsr	DisplayString

	?TimerServiceOK:
			inc	TimerCounter
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestSystemTimer
;	Function		: Test function of System Timer counter with interrupt.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestSystemTimer:
			ldy	#00h
			sty	TempX
			sty	TempY
			sty	TimerCounter
			sty	TimerCounterH
			sty	PalleteMode

			lda	#<ClockTimerService
			sta	TimerVector
			lda	#>ClockTimerService
			sta	TimerVectorH

			lda	SystemIRQMaskBuff	; enable Timer Interrupt of System Interrupt Mask.
			and	#01111111b
			sta	SystemIRQMaskBuff
			sta	SystemIRQMask

			lda	#244d			; preset counter value for 0.5 Sec per interrupt.
			sta	SetTimerValue		; the formule as 64uS * 16 * 489 = 0.500736 Sec.

			lda	#11101111b		; enable system timer and set function as follow:
			sta	SystemTimerControl	;	- Autoload counter value for continues count.
							;	- Use H-Blank as clock source(15625 Hz).

	?WaitKeyPress1:
			lda	Joystick1Data
			beq	?WaitKeyPress1

			lda	#111d			; preset counter value for 0.001001 Sec per interrupt.
			sta	SetTimerValue		; the formule as 8.939uS * 16 * 112 = 0.001001Sec.

			lda	#11001111b		; enable system timer and set function as follow:
			sta	SystemTimerControl	;	- Autoload counter value for continues count.
							;	- Use SystemClock as clock source(1.7898 MHz).

			lda	#FFh
			sta	PalleteMode		; set Pallete Mode flag as a flag for Timer Clock Source
							; Mode selection.
	?WaitKeyRelease:
			lda	Joystick1Data
			bne	?WaitKeyRelease

	?WaitKeyPress2:
			lda	Joystick1Data
			beq	?WaitKeyPress2

			lda	#01101111b		; enable system timer and set function as follow:
			sta	SystemTimerControl	;	- Autoload counter value for continues count.
							;	- Use H-Blank as clock source(15625 Hz).

			lda	SystemIRQMaskBuff	; disable Timer Interrupt of System Interrupt Mask.
			ora	#10000000b
			sta	SystemIRQMaskBuff
			sta	SystemIRQMask
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: SetupTimerValue
;	Function		: Setup count value to Timer Counter for mS per period.
;	Input Parameter	: A register - Base value for total counte time(A * 1mS).
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
SetupTimerValue:
			sec
			sbc	#01h			; let time value - 1 for count from 0.
			sta	SetTimerValue		; setup timer value for System Timer Counter.

			lda	#01111111b		; enable Timer Interrupt.
			and	SystemIRQMaskBuff
			sta	SystemIRQMaskBuff
			sta	SystemIRQMask

			lda	#10101111b		; setup System Timer Counter for 1.024mS per period.
			sta	TimerControlBuff	; and use H-Blank as clock source.
			sta	SystemTimerControl	; then enable System Timer Counter.

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: XOffsetService
;	Function		: Change X position for screen during each horizontal blank.
;	Input Parameter	: TempX - Index of X offset table.
;	Return Parameter	: TempX - New index value for index to next horizontal line of X offset table.
;-------------------------------------------------------------------------------------------------------------------------------------
;
XOffsetService:
			ldx	TempX
			lda	PositionX
			ldy	PositionY

			clc
			adc	XOffsetTable,x

			sta	ScreenPosition
			sty	ScreenPosition

			inc	TempX

	?XOffsetServiceOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: NormalTimerService
;	Function		: Count Timer for Communication Time Out during Keyboard communication.
;	Input Parameter	: TimerCounter - Counte times for Timer Interrupt.
;	Return Parameter	: TimerCounter - (TimerCounter - 1) for each interrupt by Timer.
;-------------------------------------------------------------------------------------------------------------------------------------
;
NormalTimerService:
			dec	TimerCounter		; let count times decrease by 1.
			beq	?DisableTimer		; if counter = 0 then disable timer interrupt.

			lda	TimerControlBuff
			ora	#10000000b		; re-trigger Timer Interrupt for counter again.
			sta	SystemTimerControl
			bne	?TimerServiceOK

	?DisableTimer:
			lda	SystemIRQMaskBuff
			ora	#10000000b		; disable Timer Interrupt.
			sta	SystemIRQMaskBuff

	?TimerServiceOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: SendKeyboardCmd
;	Function		: Send a 8Bits command to Keyboard and waiting for acknowledge.
;	Input Parameter	: A register - Contain the command data for who want to sended.
;	Return Parameter	: A register - Acknowledge code from Keyboard.
;-------------------------------------------------------------------------------------------------------------------------------------
;
SendKeyboardCmd:
			sta	KeyboardDataOut	; set command data into Keyboard data output port.
			
			lda	#00000001b		; setup communication direction as NT6578 to Keyboard
			sta	KeyboardControl	; and pull CLK to low for prepare to send command.

			lda	#01h
			sta	TimerCounter		; setup Timer Counter as flag for Timer Interrupt.

			lda	#80d			; setup Timer Interrupt as 80mS as setup time for
			jsr	SetupTimerValue	; NT6578 send command to Keyboard.

	?Wait80mS:
			lda	TimerCounter		; check Timer Counter for wait 80mS.
			bne	?Wait80mS

			lda	#01h
			sta	TimerCounter		; setup Timer Counter as flag for Timer Interrupt.

			lda	#80d			; setup Timer Interrupt as 80mS as recive time for
			jsr	SetupTimerValue	; wait Keyboard read command from NT6578.

			lda	#10100000b		; setup the trigger edge to falling edge of CLK signle
			sta	SpecialControl		; for send command to Keyboard or PS/2 Mouse

			lda	#00h
			sta	KeyboardInterrupt

			lda	#10000101b		; pull high of CLK for ready to send command.
			sta	KeyboardControl	; and enable the recive colock function for trigger
							; software to change the communication direction.
	?WaitChange:
			lda	KeyboardInterrupt
			bne	?WaitChangeOK

			lda	TimerCounter
			bne	?WaitChange

	?WaitChangeOK:
			lda	#00h
			sta	KeyboardInterrupt	; clear Keyboard Interrupt flag.

			lda	#01h
			sta	TimerCounter		; setup Timer Counter as flag for Timer Interrupt.

			lda	#20d			; setup Timer Interrupt as 20mS for read the
			jsr	SetupTimerValue	; acknowledge from Keyboard to NT6578.

			lda	#10000000b		; setup trigger edge to rising edge of CLK single
			sta	SpecialControl		; for recive data from Keyboard or PS/2 Mouse.

			lda	#10000000b
			sta	KeyboardControl

	?WaitACK:
			lda	KeyboardInterrupt	; check Keyboard Interrupt flag for recive ACK yet?
			bne	?ReciveACK		; yes, then exit wait loop.

			lda	TimerCounter		; else check Timer Counter for wait 20mS.
			bne	?WaitACK		; if still not recive Keyboard Interrupt then setup Time-out
							; error during Keyboard communication.
			lda	#FFh			; setup #FFh as Time-Out code for response.
			bne	?SendCommandOK

	?ReciveACK:
;			lda	SystemIRQMaskBuff
;			and	#01111111b		; disable Timer Interrupt.
;			sta	SystemIRQMaskBuff
;			sta	SystemIRQMask
;
			lda	TimerControlBuff	; get original Timer Control register and disable
			and	#01111111b		; System Timer.
			sta	SystemTimerControl

			lda	KeyboardData		; get Keyboard Data to A register for return.

	?SendCommandOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: KeyboardReset
;	Function		: Reset Keyboard for ready to Test.
;	Input Parameter	: None.
;	Return Parameter	: A register - Response code of reset the Keyboard.
;					AAh - Reset OK.
;					55h - Data communication error code.
;					FFh - Time Out error code.
;-------------------------------------------------------------------------------------------------------------------------------------
;
KeyboardReset:
			lda	#FFh			; reset Keyboard for Keyboard Initial.
			jsr	SendKeyboardCmd

			cmp	#FFh			; check response code for Time-Out error?
			beq	?TimeOutError1

			cmp	#FAh			; check response code for ACK?
			beq	?SystemRespon

	?DataError1:
			lda	#02h			; setup A register as FFh as Time-Out code.
			jmp	?KeyboardResetOK

	?TimeOutError1:
			lda	#01h			; setup A register as FFh as Time-Out code.
			jmp	?KeyboardResetOK

	?SystemRespon:
			lda	#01h
			sta	TimerCounter		; setup Timer Counter as flag for Timer Interrupt.
			jsr	SetupTimerValue	; and wait 1 mS as System acknowledge to Keyboard.

	?SystemACK:
			lda	TimerCounter
			bne	?SystemACK		; wait 1 mS for response acknowledge to Keyboard.

			lda	#10000000b		; pull high of CLK for ready read ACK from Keyboard.
			sta	KeyboardControl

			lda	#02h			; setup Timer Counter as 2 times interrupt for total 512 mS.
			sta	TimerCounter
			lda	#250d			; setup Timer Interrupt as 250 mS per time for waiting the
			jsr	SetupTimerValue	; response of Basic Assurance Test.

			lda	#00h
			sta	KeyboardInterrupt	; clear Keyboard Interrupt flag.

	?WaitKeyboardReset:
			lda	KeyboardInterrupt	; check Keyboard Interrupt for response from Keyboard yet?
			bne	?ReciveResponse

			lda	TimerCounter
			bne	?WaitKeyboardReset

	?TimeOutError2:
			lda	#03h			; setup A register as FFh as Time-Out code.
			jmp	?KeyboardResetOK

	?ReciveResponse:
			lda	KeyboardData
			cmp	#AAh
			beq	?KeyboardResetOK

	?DataError2:
			lda	#04h			; setup A register as 55h as Data Error code.

	?KeyboardResetOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: DetectKeyboard
;	Function		: Test Keyboard communication function with PC/AT 101 keys keyboard.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
DetectKeyboard:
			txa
			pha
			tya
			pha

			lda	#FFh
			sta	KeyboardCmd

			lda	#11011111b		; enable Keyboard Interrupt.
			and	SystemIRQMaskBuff
			sta	SystemIRQMaskBuff
			sta	SystemIRQMask

			lda	#<NormalTimerService
			sta	TimerVector		; set new Timer Interrupt Service routine for Keyboard.
			lda	#>NormalTimerService
			sta	TimerVectorH

			jsr	KeyboardReset	; goto reset Keyboard for ready to test.
			cmp	#AAh
			beq	?ReadDeviceID	; if return code not #AAh, then exit test routine.
			jmp	?SetKeyboardMissed

	?ReadDeviceID:
			lda	#F2h
			jsr	SendKeyboardCmd	; send command #F2 for read device ID.

			cmp	#FAh
			beq	?ReadID
			jmp	?SetKeyboardMissed

	?ReadID:
			lda	#00h
			sta	KeyboardInterrupt	; clear Keyboard Interrupt flag.

			lda	#01h
			sta	TimerCounter		; setup Timer Counter as flag for Timer Interrupt.
			lda	#25d
			jsr	SetupTimerValue	; and wait for response within 25mS.

			lda	#10000000b		; set communcation direction for key data from
			sta	KeyboardControl	; Keyboard.

	?WaitingForID:
			lda	KeyboardInterrupt	; check for keyboard data input complete?
			bne	?Read1stID

			lda	TimerCounter
			bne	?WaitingForID		; wait 1 mS for response acknowledge to Keyboard.

	?Read1stID:
			lda	KeyboardData
			cmp	#00h			; if ID code same as #00h, then start PS/2 Mouse process
			bne	?ReadKeyboardID	; otherwise goto Keyboard process.

			lda	#01h
			sta	PS2MouseExist
			bne	?SetPS2Detected

	?ReadKeyboardID:
			lda	#00h
			sta	KeyboardInterrupt

			lda	#01h
			sta	TimerCounter		; setup Timer Counter as flag for Timer Interrupt.
			lda	#25d
			jsr	SetupTimerValue	; and wait for response within 25mS.

			lda	#10000000b		; set communcation direction for key data from
			sta	KeyboardControl	; Keyboard.

	?WaitingKeyboardID:
			lda	KeyboardInterrupt	; check for second keyboard ID data input complete?
			bne	?SendLEDCmd

			lda	TimerCounter
			bne	?WaitingKeyboardID	; wait 1 mS for response acknowledge to Keyboard.

	?SendLEDCmd:
			lda	#EDh			; send command #EDh for turn lights of LED.
			jsr	SendKeyboardCmd
			cmp	#FAh			; check for recive the acknowledge from Keyboard?
			beq	?SendLEDParameter	; if return code not #FAh, then exit test routine.
			jmp	?SetKeyboardMissed

	?SendLEDParameter:
			lda	#00000010b		; send second byte of command for turn lights of
			jsr	SendKeyboardCmd	; the 'NumLock' LED.
			cmp	#FAh			; check for recive the acknowledge from Keyboard?
			beq	?SendCodeCmd	; if return code not #FAh, then exit test routine.
			jmp	?SetKeyboardMissed

	?SendCodeCmd:
			lda	#F0h			; send command #F0h for select the set of scan code.
			jsr	SendKeyboardCmd
			cmp	#FAh			; check for recive the acknowledge from Keyboard?
			beq	?SendCodeParameter	; if return code not #FAh, then exit test routine.
			jmp	?SetKeyboardMissed

	?SendCodeParameter:
			lda	#01h			; send second byte of command for select set 1 as
			jsr	SendKeyboardCmd	; the default scan code.
			cmp	#FAh			; check for recive the acknowledge from Keyboard?
			bne	?SetKeyboardMissed	; if return code not #FAh, then exit test routine.

	?SetKeyboardDetected:
			lda	#<?KeyboardDetected
			sta	IndexAddr
			lda	#>?KeyboardDetected
			sta	IndexAddrH
			bne	?ShowDetectedString

	?SetPS2Detected:
			lda	#<?PS2MouseDetected
			sta	IndexAddr
			lda	#>?PS2MouseDetected
			sta	IndexAddrH

	?ShowDetectedString:
			lda	#01d
			sta	PalleteNumber

			jsr	ShowString8		; call for display resoult string.

			inc	RowIndex

			ldy	#00h

	?MoveString1:
			lda	?KeyboardID,y	; move default string into buffer.
			sta	PageBuffer,y

			iny
			cmp	#FFh			; if not end of string then keep moving.
			bne	?MoveString1			

	?SendReadIDCmd:
			lda	#F2h			; send command #F0h for select the set of scan code.
			jsr	SendKeyboardCmd

			lda	PS2MouseExist
			bne	?ReadKeyLoop

			ldx	#02d			; set X register for read 2 Bytes ID from Keyboard,

	?ReadKeyLoop:
			lda	#00h
			sta	KeyboardInterrupt	; clear Keyboard Interrupt flag.

			lda	#10000000b		; set communcation direction for key data from
			sta	KeyboardControl	; Keyboard.

	?WaitKeyboard:
			lda	KeyboardInterrupt	; check for keyboard data input complete?
			beq	?WaitKeyboard

			ldy	PS2MouseExist
			bne	?TransferID

			dex
			beq	?TransferID

			lda	KeyboardData
			sta	TempA
			jmp	?ReadKeyLoop

	?TransferID:
			lda	KeyboardData
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+11

			lda	KeyboardData
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+12

			lda	PS2MouseExist
			bne	?ShowResoult

			lda	TempA
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+13

			lda	TempA
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+14

			lda	#FFh
			sta	KeyboardExist
			jmp	?ShowResoult

	?SetKeyboardMissed:
			pha

			lda	#<?KeyboardMissed
			sta	IndexAddr
			lda	#>?KeyboardMissed
			sta	IndexAddrH

			lda	#02d
			sta	PalleteNumber

			jsr	ShowString8		; call for display resoult string.

			inc	RowIndex

			ldy	#00h

	?MoveString2:
			lda	?KeyboardResponse,y	; move default string into buffer.
			sta	PageBuffer,y

			iny
			cmp	#FFh			; if not end of string then keep moving.
			bne	?MoveString2			

			pla
			tax
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+13

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+14

			lda	#00h
			sta	KeyboardExist

	?ShowResoult:
			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

			lda	#00d
			sta	PalleteNumber

			jsr	ShowString8		; call for display resoult string.

	?DetectKeyboardFinished:
			lda	#00h
			sta	KeyboardCmd

			pla
			tay
			pla
			tax

			rts
;
	?KeyboardDetected:
			db	"Keyboard detect", $FFh
	?PS2MouseDetected:
			db	"PS/2 Mouse detect", $FFh
	?KeyboardMissed:
			db	"Keyboard missed", $FFh
	?KeyboardID:
			db	"I.D. Code:     ", $FFh
	?KeyboardResponse:
			db	"Return Code:   ", $FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: Lsb2ASCII
;	Function		: Convert  D3-D0 to ASCII code from one byte data.
;	Input Parameter	: A register - Contain the data who want to be converted.
;	Return Parameter	: A register - Contain the new data by ASCII code.
;-------------------------------------------------------------------------------------------------------------------------------------
;
Lsb2ASCII:
			and	#0Fh			; mark MSB for get D3-D0.

			cmp	#0Ah			; if LSB value between A-F then goto set character code.
			bcs	?SetAtoF		; else set for number code.

			ora	#30h			; convert to number of ASCII code.
			bne	?ConvertOK

	?SetAtoF:
			sec
			sbc	#09h			; let contain value subtract by 9 for ready to convert.
			ora	#40h			; convert to character of ASCII code.

	?ConvertOK:
			rts
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: Msb2ASCII
;	Function		: Convert  D7-D4 to ASCII code from one byte data.
;	Input Parameter	: A register - Contain the data who want to be converted.
;	Return Parameter	: A register - Contain the new data by ASCII code.
;-------------------------------------------------------------------------------------------------------------------------------------
;
Msb2ASCII:
			and	#F0h			; mark LSB for get D7-D4.

			lsr	A			; left shift 4 bits for ready to convert to ASCII code.
			lsr	A
			lsr	A
			lsr	A

			cmp	#0Ah			; if LSB value between A-F then goto set character code.
			bcs	?SetAtoF		; else set for number code.

			ora	#30h			; convert to number of ASCII code.
			bne	?ConvertOK

	?SetAtoF:
			sec
			sbc	#09h			; let contain value subtract by 9 for ready to convert.
			ora	#40h			; convert to character of ASCII code.

	?ConvertOK:
			rts
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestDMAMode2
;	Function		: Move 8 KBytes data from $8000h~$9FFFh of ROM area to $6000h~$7FFFh
;				  of Working RAM area, and test the reslut for verify function of DMA mode 2.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestDMAMode2:
			lda	#<?TestTitle
			sta	IndexAddr
			lda	#>?TestTitle
			sta	IndexAddrH
;			jsr	DisplayTitle		; call for show title of test item.

			lda	#<?TestString
			sta	IndexAddr
			lda	#>?TestString
			sta	IndexAddrH
			lda	#0
			sta	ColumnIndex
;			jsr	DisplayString		; call for show the testing message.

			lda	#00h
			sta	DMASourceBank	; setup bank 0 for  DMA source bank.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#1Fh			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $1FFF + 1 = 2000h bytes.

			lda	#00h			; setup low byte address of DMA source.
			sta	DMASourceL
			lda	#80h			; setup high byte address of DMA source.
			sta	DMASourceH

			lda	#<WorkBuffer		; setup low byte address of DMA destination.
			sta	DMADestinationL
			lda	#>WorkBuffer		; setup high byte address of DMA destination.
			sta	DMADestinationH

			lda	#10100000b		; enable DMA mode 2 to move data.
			sta	DMAControl

			lda	#00h			; setup low byte address of compare source.
			sta	IndexAddr
			lda	#80h			; setup high byte address of compare source.
			sta	IndexAddrH
			ldx	#60h			; setup high byte address of compare destination.
			stx	PageBuffAddrH
			ldy	#00h			; setup low byte address of compare destination.
			sty	PageBuffAddr

	?TestDataLoop:
			lda	(PageBuffAddr),y
			cmp	(IndexAddr),y
			bne	?TestFail

			iny
			bne	?TestDataLoop

			inc	PageBuffAddrH
			inc	IndexAddrH
			inx
			cpx	#80h
			bne	?TestDataLoop

			lda	#<TestOK
			sta	IndexAddr
			lda	#>TestOK
			sta	IndexAddrH
			lda	#11d
			sta	ColumnIndex

			jmp	?ShowResult

	?TestFail:
			tya
			pha
			ldy	#00h

	?MoveString:
			lda	?FailString,y		; move default string into buffer.
			sta	PageBuffer,y

			iny
			cmp	#FFh			; if not end of string then keep moving.
			bne	?MoveString

			lda	PageBuffAddrH
			tay
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+2		; setup ASCII code as $Zxxx - NN(OO)"
			tya
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+3		; setup ascii CODE as $xZxx - NN(OO)"

			pla
			tay
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+4		; setup ASCII code as $xxZx - NN(OO)"
			tya
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+5		; setup ascii CODE as $xxxZ - NN(OO)"

			lda	(PageBuffAddr),y
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+9		; setup ASCII code as $xxxx - ZN(OO)"
			lda	(PageBuffAddr),y
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+10		; setup ascii CODE as $xxxx - NZ(OO)"

			lda	(IndexAddr),y
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+12		; setup ASCII code as $xxxx - NN(ZO)"
			lda	(IndexAddr),y
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+13		; setup ascii CODE as $xxxx - NN(OZ)"

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

			lda	#00h
			sta	ColumnIndex

	?ShowResult:
;			jsr	DisplayString

			ldy	#60d
			jsr	WaitNMI

			rts
	?TestTitle:
			db	"DMA Mode 2 Test", $FFh
	?TestString:
			db	"Mode 2 Testing", $FFh
	?FailString:
			db	" $xxxx - NN(OO)", $FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: DMAPNT16
;	Function		: DMA PNT data from work buffer to VRAM.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
DMAPNT16:
;			lda	#00h
;			sta	VRAMAddress
;			lda	#00h
;			sta	VRAMAddress
;
;			lda	#>WorkBuffer		; set high byte of index of 8 KBytes PNT table.
;			sta	IndexAddrH
;			lda	#<WorkBuffer
;			sta	IndexAddr
;
;			lda	#00h
;			ldx	#20h			; set for transfer 4 Pages PNT data into VRAM.
;
;			tay				; setup page counter.
;
;	?FillPNT16:
;			lda	(IndexAddr),y		; store low byte of PNT data.
;			sta	VRAMData
;
;			iny
;			bne	?FillPNT16
;
;			inc	IndexAddrH
;			dex
;			bne	?FillPNT16
;
			lda	#00h			; setup bank select of DMA source to Bank 1 for
			sta	DMASourceBank	; background PGT data.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#1Fh			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $1FFF + 1 = 2000h bytes.

			lda	#00h			; setup low byte address of DMA source and destination.
			sta	DMADestinationL
			sta	DMADestinationH

			lda	#>WorkBuffer		; set high byte of index of 1 KBytes buffer.
			sta	DMASourceH
			lda	#<WorkBuffer
			sta	DMASourceL

			lda	#11000000b		; enable DMA mode 0 for move background PGT data from
			sta	DMAControl		; $8000~$FFFF of bank 1 to $0000~$1FFF of VRAM.

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: InitBGPNT16
;	Function		: Transfer 2048 bytes PNT data for 4 pages display into VRAM from ROM
;				  for NT6578 mode,
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
InitBGPNT16:
			lda	#00h
			sta	PageIndex

	?CorrectLoop:
			ldx	?MoveLength
			ldy	#00h

	?MoveRoutine:
			lda	?MovePNTroutine,y	; move subroutine to RAM for switch program section
			sta	TempBuffer,y		; from bank 0 to bank 2 for move PNT data.

			iny
			dex
			bne	?MoveRoutine

			lda	SystemControlBuff	; disable NMI during move PGT process, because move
			and	#01111111b		; move PGT process will change program bank from 0
			sta	SystemControl		; to 1(total 32 KBytes), may cause problem if NMI occurs.

			sei				; also disable IRQ too.

			jsr	TempBuffer		; goto move PGT data from bank 1 to VRAM

			cli

			lda	SystemControlBuff	; restore original config of System Control register.
			sta	SystemControl

;			lda	#02h			; setup bank select of DMA source to Bank 2 for
;			sta	DMASourceBank	; background PNT data.
;
;			lda	#FFh
;			sta	DMALengthL		; setup low byte of DMA length.
;			lda	#07h			; setup high byte of DMA length.
;			sta	DMALengthH		; for total transfer length = $07FF + 1 = 0800h bytes.
;
;			lda	#00h			; setup low byte address of DMA source and destination.
;			sta	DMASourceL
;			txa	
;			asl	A
;			asl	A
;			asl	A
;			clc
;			adc	#80h			; transfer page index to real address for after $8000h on
;			sta	DMASourceH		; bank 2 of program ROM area.
;
;			lda	#>WorkBuffer		; set high byte of index of 1 KBytes buffer.
;			sta	DMADestinationH
;			lda	#<WorkBuffer
;			sta	DMADestinationL
;
;			lda	#11100000b		; enable DMA mode 1 for move background PNT data from
;			sta	DMAControl		; $8000~$FFFF of bank 1 to $5000~$57FF of VRAM.
;
			lda	#00h			; setup bank select of DMA source to Bank 1 for
			sta	DMASourceBank	; background PGT data.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#07h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $07FF + 1 = 0800h bytes.

			lda	#00h			; setup low byte address of DMA source and destination.
			sta	DMADestinationL
			lda	PageIndex
			asl	A
			asl	A
			asl	A
			sta	DMADestinationH

			lda	#>WorkBuffer		; set high byte of index of 1 KBytes buffer.
			sta	DMASourceH
			lda	#<WorkBuffer
			sta	DMASourceL

			lda	#11000000b		; enable DMA mode 2 for move background PNT data from
			sta	DMAControl		; $5000~$57FF of bank 0 to $0000~$2FFF of VRAM.

			inc	PageIndex
			lda	PageIndex
			cmp	#04h
			bne	?CorrectLoop

			rts
;
	?MovePNTroutine:
			ldx	#00010000b		; change section 0 to bank 2.
			stx	$4040h
			inx				; change section 1 to bank 2.
			stx	$4041h
			inx				; change section 2 to bank 2.
			stx	$4042h
			inx				; change section 3 to bank 2.
			stx	$4043h
			inx				; change section 4 to bank 2.
			stx	$4044h
			inx				; change section 5 to bank 2.
			stx	$4045h
			inx				; change section 6 to bank 2.
			stx	$4046h
			inx				; change section 7 to bank 2.
			stx	$4047h

			lda	PageIndex
			asl	A
			asl	A
			asl	A
			clc
			adc	#80h
			sta	IndexAddrH		; setup high byte of index for PGT data.
			lda	#00h
			sta	IndexAddr		; setup low byte of index for PGT data.

			lda	#>WorkBuffer		; set high byte of index of 8 KBytes buffer for correct
			sta	PageBuffAddrH	; the PNT sequence of NT6578 cut 1 problem.
			lda	#<WorkBuffer		; set low byte of index of 8 KBytes buffer for correct
			sta	PageBuffAddr		; the PNT sequence of NT6578 cut 1 problem.

			ldy	#00h			; setup page counter.
			ldx	#08h			; set for transfer 1 Pages PNT data into VRAM.

	?FillPNT16:
			lda	(IndexAddr),y		; store low byte of PNT data.
			sta	(PageBuffAddr),y	; store into buffer for re-sort sequence of PNT table.
			sta	VRAMData
			iny

			lda	(IndexAddr),y		; let high byte of PNT data index to external VRAM for
			ora	#08h			; PGT data.
			sta	(PageBuffAddr),y	; store into buffer for re-sort sequence of PNT table.
			sta	VRAMData

			iny
			bne	?FillPNT16

			inc	IndexAddrH

			inc	PageBuffAddrH

			dex
			bne	?FillPNT16

			ldx	#00000000b		; change section 0 to bank 0.
			stx	$4040h
			inx				; change section 1 to bank 0.
			stx	$4041h
			inx				; change section 2 to bank 0.
			stx	$4042h
			inx				; change section 3 to bank 0.
			stx	$4043h
			inx				; change section 4 to bank 0.
			stx	$4044h
			inx				; change section 5 to bank 0.
			stx	$4045h
			inx				; change section 6 to bank 0.
			stx	$4046h
			inx				; change section 7 to bank 0.
			stx	$4047h

			rts
	?MoveLength:
			db	?MoveLength-?MovePNTroutine
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ClearBGPNT
;	Function		: Clear 10K Bytes PNT data.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ClearBGPNT:
			lda	#02h			; setup bank select of DMA source to Bank 2 for
			sta	DMASourceBank	; background PNT data.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#27h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $27FF + 1 = 2800h bytes.

			lda	#00h			; setup low byte address of DMA source and destination.
			sta	DMASourceL
			sta	DMADestinationL

			lda	#80h			; setup high byte address of DMA source and destination.
			sta	DMASourceH
			sta	DMADestinationH

			lda	#11000000b		; enable DMA mode 2 for move background PNT data from
			sta	DMAControl		; $8000~$FFFF of bank 2 to $0000~$27FF of VRAM.

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ClearPGT32
;	Function		: Clear 32K Bytes PGT data.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ClearPGT32:
			lda	#02h			; setup bank select of DMA source to Bank 2 for
			sta	DMASourceBank	; background PGT data.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#7Fh			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $7FFF + 1 = 8000h bytes.

			lda	#00h			; setup low byte address of DMA source and destination.
			sta	DMASourceL
			sta	DMADestinationL

			lda	#80h			; setup high byte address of DMA source and destination.
			sta	DMASourceH
			sta	DMADestinationH

			lda	#11000000b		; enable DMA mode 2 for move background PGT data from
			sta	DMAControl		; $8000~$FFFF of bank 1 to $8000~$FFFF of VRAM.

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: InitBGPGT32
;	Function		: Transfer 32K Bytes PGT data into VRAM from ROM for NT6578 mode,
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
InitBGPGT32:
			lda	#01h			; setup bank select of DMA source to Bank 1 for
			sta	DMASourceBank	; background PGT data.

			lda	#FFh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#7Fh			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $7FFF + 1 = 8000h bytes.

			lda	#00h			; setup low byte address of DMA source and destination.
			sta	DMASourceL
			sta	DMADestinationL

			lda	#80h			; setup high byte address of DMA source and destination.
			sta	DMASourceH
			sta	DMADestinationH

			lda	#11000000b		; enable DMA mode 0 for move background PGT data from
			sta	DMAControl		; $8000~$FFFF of bank 1 to $8000~$FFFF of VRAM.

			rts
;
; ***** the following routine used for correct PPU bug of NT6578 cut-1 only *****
; ***** if this bug will corrected on cut-2 or later cuts, use the routine at above *****
; ***** and do not use the correct routine as below on cut-2 version of NT6578 *****
;
;			lda	#80h
;			sta	IndexAddrH
;			sta	MapAddrH
;
;			lda	#01h			; setup bank select of DMA source to Bank 1 for
;			sta	DMASourceBank	; background PGT data.
;
;			lda	#FFh
;			sta	DMALengthL		; setup low byte of DMA length.
;			lda	#01h			; setup high byte of DMA length.
;			sta	DMALengthH		; for total transfer length = $01FF + 1 = 0200h bytes.
;			lda	#00h			; setup low byte address of DMA source and destination.
;			sta	DMASourceL
;			sta	DMADestinationL
;
;			ldx	#32d			; setup X register as loop counter for DMA 32 times and
;							; 512 bytes per DMA by 2 times DMA on each loop.
;	?DMALoop:
;			lda	IndexAddrH		; setup high byte address of DMA source and destination.
;			sta	DMASourceH
;
;			lda	MapAddrH
;			sta	DMADestinationH
;
;			lda	#10000000b		; enable DMA mode 0 for move background PGT data from
;			sta	DMAControl		; $8000~$FFFF of bank 1 to $8000~$FFFF of VRAM.
;
;			lda	IndexAddrH
;			ora	#01000000b
;			sta	DMASourceH
;
;			clc
;			lda	MapAddrH
;			adc	#02h
;			sta	MapAddrH
;			sta	DMADestinationH
;
;			lda	#11000000b		; enable DMA mode 0 for move background PGT data from
;			sta	DMAControl		; $8000~$FFFF of bank 1 to $8000~$FFFF of VRAM.
;
;			clc
;			lda	IndexAddrH
;			adc	#02h
;			sta	IndexAddrH
;
;			clc
;			lda	MapAddrH
;			adc	#02h
;			sta	MapAddrH
;			sta	DMADestinationH
;
;			dex
;			bne	?DMALoop
;
;			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestVRAM
;	Function		: Test extend VRAM within $8000h~$FFFFh for 32KByts.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestVRAM:
			txa
			pha
			tya
			pha

			lda	VideoControlBuff
			and	#11100111b
			sta	VideoControl

			ldy	#00h

	?MoveString:
			lda	?TestString,y		; move default string into buffer.
			sta	PageBuffer,y

			iny
			cmp	#FFh			; if not end of string then keep moving.
			bne	?MoveString			

			ldx	#80h
			ldy	#00h

			txa
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+1		; set to buffer as "$Nx00-$NxFF"

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+2		; set to buffer as "$xN00-$xNFF"

	?TestVRAMArea:
			stx	VRAMAddress
			sty	VRAMAddress

			lda	#55h
			sta	VRAMData

			stx	VRAMAddress
			sty	VRAMAddress
			lda	VRAMData

			lda	VRAMData
			cmp	#55h
			bne	?SetErrorCode

			stx	VRAMAddress
			sty	VRAMAddress
			lda	#AAh
			sta	VRAMData

			stx	VRAMAddress
			sty	VRAMAddress
			lda	VRAMData

			lda	VRAMData
			cmp	#AAh
			bne	?SetErrorCode

			iny
			bne	?TestVRAMArea

			inx
			bne	?TestVRAMArea

			dex
			txa
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+7

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+8

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

			lda	#00d
			sta	PalleteNumber

			jsr	ShowString8		; call for display string on screen.

			lda	#<TestOK
			sta	IndexAddr
			lda	#>TestOK
			sta	IndexAddrH

			lda	#01d
			sta	PalleteNumber
			jmp	?ShowResoult

	?SetErrorCode:
			txa
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+7

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+8

			tya
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+9

			tya
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+10

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

			lda	#00d
			sta	PalleteNumber

			jsr	ShowString8		; call for display string on screen.

			lda	#<TestFail
			sta	IndexAddr
			lda	#>TestFail
			sta	IndexAddrH

			lda	#02d
			sta	PalleteNumber

	?ShowResoult:
			clc
			lda	ColumnIndex		; set start position for display resoult.
			pha
			adc	#11d
			sta	ColumnIndex

			jsr	ShowString8		; call for display resoult string.
			pla
			sta	ColumnIndex

	?TestVRAMOK:
			lda	VideoControlBuff
			sta	VideoControl

			pla
			tay
			pla
			tax

			rts
;
	?TestString:
			db	"$XX00-$XXFF", $FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestExtendRAM
;	Function		: Test extend RAM within $6000h~$7FFFh for 8KBytes.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestExtendRAM:
			txa
			pha
			tya
			pha

			lda	#80h
			sta	CurrentPage		; set 32 to CurrentPage as testing loop counter for test
							; Working RAM from $0200h~$1FFFh
			ldx	#60h

			ldy	#00h

	?MoveString:
			lda	?TestString,y		; move default string into buffer.
			sta	PageBuffer,y

			iny
			cmp	#FFh			; if not end of string then keep moving.
			bne	?MoveString			

			txa
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+1		; set to buffer as "$Nx00-$NxFF"

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+2		; set to buffer as "$xN00-$xNFF"

	?TestExtendRAMLoop:
			txa
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+7

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+8

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

	?DisplayLabel:
			lda	#00d
			sta	PalleteNumber

			jsr	ShowString8		; call for display string on screen.

			ldy	#00h
			stx	PageBuffAddrH
			sty	PageBuffAddr

	?SetRAM55:
			lda	(PageBuffAddr),y
			sta	TempA
			lda	#55h
			sta	(PageBuffAddr),y

	?ReadRAM55:
			lda	(PageBuffAddr),y
			cmp	#55h
			bne	?ReadDataError

	?SetRAMAA:
			lda	#AAh
			sta	(PageBuffAddr),y

	?ReadRAMAA:
			lda	(PageBuffAddr),y
			cmp	#AAh
			bne	?ReadDataError

			lda	TempA
			sta	(PageBuffAddr),y

			iny
			bne	?SetRAM55

	?ShowTestOK:
			lda	#<TestOK
			sta	IndexAddr
			lda	#>TestOK
			sta	IndexAddrH

			lda	#01d
			sta	PalleteNumber
			jmp	?ShowResoult

	?ReadDataError:
			tya
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+9		; set to buffer as "$xxN0"

			tya
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+10		; set to buffer as "$xxxN"

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

			jsr	ShowString8

			lda	#<TestFail
			sta	IndexAddr
			lda	#>TestFail
			sta	IndexAddrH

			lda	#02d
			sta	PalleteNumber

			clc
			lda	ColumnIndex		; set start position for display resoult.
			pha
			adc	#11d
			sta	ColumnIndex

			jsr	ShowString8		; call for display resoult string.
			pla
			sta	ColumnIndex
			jmp	?TestExtendRAMOK

	?ShowResoult:
			clc
			lda	ColumnIndex		; set start position for display resoult.
			pha
			adc	#11d
			sta	ColumnIndex

			jsr	ShowString8		; call for display resoult string.
			pla
			sta	ColumnIndex

	?WaitKeyLoop:
			inx
			cpx	CurrentPage
			beq	?TestExtendRAMOK

			jmp	?TestExtendRAMLoop

	?TestExtendRAMOK:
			pla
			tay
			pla
			tax

			rts
;
	?TestString:
			db	"$XX00-$XXFF", $FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestWorkRAM2
;	Function		: Test work RAM area 2 within $5000h~$57FFh for 2KBytes.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestWorkRAM2:
			txa
			pha
			tya
			pha

			lda	#58h
			sta	CurrentPage		; set 32 to CurrentPage as testing loop counter for test
							; Working RAM from $0200h~$1FFFh
			ldx	#50h
			ldy	#00h

	?MoveString:
			lda	?TestString,y		; move default string into buffer.
			sta	PageBuffer,y

			iny
			cmp	#FFh			; if not end of string then keep moving.
			bne	?MoveString			

			txa
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+1		; set to buffer as "$Nx00-$NxFF"

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+2		; set to buffer as "$xN00-$xNFF"

	?TestWorkRAMLoop:
			txa
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+7

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+8

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

	?DisplayLabel:
			lda	#00d
			sta	PalleteNumber

			jsr	ShowString8		; call for display string on screen.

			ldy	#00h
			stx	PageBuffAddrH
			sty	PageBuffAddr

	?SetRAM55:
			lda	(PageBuffAddr),y
			sta	TempA
			lda	#55h
			sta	(PageBuffAddr),y

	?ReadRAM55:
			lda	(PageBuffAddr),y
			cmp	#55h
			bne	?ReadDataError

	?SetRAMAA:
			lda	#AAh
			sta	(PageBuffAddr),y

	?ReadRAMAA:
			lda	(PageBuffAddr),y
			cmp	#AAh
			bne	?ReadDataError

			lda	TempA
			sta	(PageBuffAddr),y

			iny
			bne	?SetRAM55

	?ShowTestOK:
			lda	#<TestOK
			sta	IndexAddr
			lda	#>TestOK
			sta	IndexAddrH

			lda	#01d
			sta	PalleteNumber
			jmp	?ShowResoult

	?ReadDataError:
			tya
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+9		; set to buffer as "$xxN0"

			tya
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+10		; set to buffer as "$xxxN"

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

			jsr	ShowString8

			lda	#<TestFail
			sta	IndexAddr
			lda	#>TestFail
			sta	IndexAddrH

			lda	#02d
			sta	PalleteNumber

			clc
			lda	ColumnIndex		; set start position for display resoult.
			pha
			adc	#11d
			sta	ColumnIndex

			jsr	ShowString8		; call for display resoult string.
			pla
			sta	ColumnIndex
			jmp	?TestWorkRAMOK

	?ShowResoult:
			clc
			lda	ColumnIndex		; set start position for display resoult.
			pha
			adc	#11d
			sta	ColumnIndex

			jsr	ShowString8		; call for display resoult string.
			pla
			sta	ColumnIndex

	?WaitKeyLoop:
			inx
			cpx	CurrentPage
			beq	?TestWorkRAMOK

			jmp	?TestWorkRAMLoop

	?TestWorkRAMOK:
			pla
			tay
			pla
			tax

			rts
;
	?TestString:
			db	"$XX00-$XXFF", $FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TestWorkRAM1
;	Function		: Test work RAM area 1 within $0000h~$1FFFh for 8KBytes.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TestWorkRAM1:
			txa
			pha
			tya
			pha

			lda	#20h
			sta	CurrentPage		; set 32 to CurrentPage as testing loop counter for test
							; Working RAM from $0200h~$1FFFh
			ldx	#02h

			ldy	#00h

	?MoveString:
			lda	?TestString,y		; move default string into buffer.
			sta	PageBuffer,y

			iny
			cmp	#FFh			; if not end of string then keep moving.
			bne	?MoveString			

			txa
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+1		; set to buffer as "$Nx00-$NxFF"
			sta	PageBuffer+7

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+2		; set to buffer as "$xN00-$xNFF"
			sta	PageBuffer+8

	?TestWorkRAMLoop:
			txa
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+7

			txa
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+8

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

	?DisplayLabel:
			lda	#00d
			sta	PalleteNumber

			jsr	ShowString8		; call for display string on screen.

			ldy	#00h
			stx	PageBuffAddrH
			sty	PageBuffAddr

	?SetRAM55:
			lda	(PageBuffAddr),y
			sta	TempA
			lda	#55h
			sta	(PageBuffAddr),y

	?ReadRAM55:
			lda	(PageBuffAddr),y
			cmp	#55h
			bne	?ReadDataError

	?SetRAMAA:
			lda	#AAh
			sta	(PageBuffAddr),y

	?ReadRAMAA:
			lda	(PageBuffAddr),y
			cmp	#AAh
			bne	?ReadDataError

			lda	TempA
			sta	(PageBuffAddr),y

			iny
			bne	?SetRAM55

	?ShowTestOK:
			lda	#<TestOK
			sta	IndexAddr
			lda	#>TestOK
			sta	IndexAddrH

			lda	#01d
			sta	PalleteNumber
			jmp	?ShowResoult

	?ReadDataError:
			tya
			jsr	Msb2ASCII		; call for convert MSB to ASCII code.
			sta	PageBuffer+9		; set to buffer as "$xxN0"

			tya
			jsr	Lsb2ASCII		; call for convert LSB to ASCII code.
			sta	PageBuffer+10		; set to buffer as "$xxxN"

			lda	#<PageBuffer
			sta	IndexAddr
			lda	#>PageBuffer
			sta	IndexAddrH

			jsr	ShowString8

			lda	#<TestFail
			sta	IndexAddr
			lda	#>TestFail
			sta	IndexAddrH

			lda	#02d
			sta	PalleteNumber

			clc
			lda	ColumnIndex		; set start position for display resoult.
			pha
			adc	#11d
			sta	ColumnIndex

			jsr	ShowString8		; call for display resoult string.
			pla
			sta	ColumnIndex
			jmp	?TestWorkRAMOK

	?ShowResoult:
			clc
			lda	ColumnIndex		; set start position for display resoult.
			pha
			adc	#11d
			sta	ColumnIndex

			jsr	ShowString8		; call for display resoult string.
			pla
			sta	ColumnIndex

	?WaitKeyLoop:
			inx
			cpx	CurrentPage
			beq	?TestWorkRAMOK

			jmp	?TestWorkRAMLoop

	?TestWorkRAMOK:
			pla
			tay
			pla
			tax

			rts
;
	?TestString:
			db	"$XX00-$XXFF", $FFh
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: InitSnapshot
;	Function		: initial snapshot data for a 4X4 sprites.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
InitSnapshot:
			lda	#80h
			sta	OffsetX
			sta	OffsetY

			ldx	#16d			; set X register as counter for total 16 sprites.
			ldy	#00h

	?SetSpriteData:
			clc
			lda	SnapshotTable,y
			adc	OffsetX
			sta	SpriteBuffer,y		; set related X position for sprite.
			iny

			lda	SnapshotTable,y
			sta	SpriteBuffer,y		; set PGT data for sprite.
			iny

			lda	SnapshotTable,y
			sta	SpriteBuffer,y
			iny

			clc
			lda	SnapshotTable,y
			adc	OffsetY
			sta	SpriteBuffer,y		; set related Y position for sprite.
			iny

			dex
			bne	?SetSpriteData

			lda	#FFh
			sta	SpriteChange

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: SnapshotUpdate
;	Function		: Celan sprite buffer and transfer into PPU for clear all sprite data.
;	Input Parameter	: SpriteLength - Total sprite number will be updated.
;				  FirstSprite - First sprite number durint snapshot update process.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
SnapshotUpdate:
			txa
			pha
			tya
			pha

			lda	FirstSprite
			asl	A
			asl	A			; let First Sprite ID X 4 for 4 bytes per Sprite data.
			tax

	?UpdateSpriteLoop:
			lda	SpriteBuffer,x		; get offset Y for sprite.
			clc
			adc	OffsetY
			sta	SpriteBuffer,x

			inx
			inx
			inx
			lda	SpriteBuffer,x		; get offset X for sprite.
			clc
			adc	OffsetX
			sta	SpriteBuffer,x

			inx

			dec	SpriteLength
			bne	?UpdateSpriteLoop

			lda	#FFh
			sta	SpriteChange

			pla
			tay
			pla
			tax

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: InitSpriteBuffer
;	Function		: Celan sprite buffer and transfer into PPU for clear all sprite data.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
InitSpriteBuffer:
			ldx	#00h
			ldy	#00h

	?InitLoop:
			cpy	#00h			; if byte 3 then set #FFh for out of display Y axis.
			bne	?ClearByte

			lda	#FFh
			bne	?StoreByte

	?ClearByte:
			lda	#00h

	?StoreByte:
			sta	SpriteBuffer,x		; clear byte 0 - 2 of each sprite data.
			iny
			cpy	#04h
			bne	?CountX
			ldy	#00h

	?CountX:
			inx
			bne	?InitLoop

			lda	#FFh
			sta	SpriteChange		; setup Sprite chang flag for ready to transfer sprite data
							; into PPU by DMA.
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: WaitNMI
;	Function		: Wait sever times NMI for delay.
;	Input Parameter	: Y register - NMI number for waiting.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
WaitNMI:
			pha
			txa
			pha
			tya
			pha

			tax
			lda	#00h
			sta	NMICounter

	?WaitLoop:
			cpx	NMICounter
			beq	?WaitOK
			bcs	?WaitLoop

	?WaitOK:
			pla
			tay
			pla
			tax
			pla
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ColorFadeOut
;	Function		: Control screen color fade out function from dark to normal by 7 steps.
;	Input Parameter	: VideoControlBuff - Current display status.
;	Return Parameter	: VideoControlBuff - screen On with normal color status.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ColorFadeOut:
			lda	VideoControlBuff	; get current status of Video Control register.
			and	#00011111b		; disable D7-D5 for ready to Fade-out process.
			sta	TempA

			ldx	#00000000b
			txa

	?FadeOutLoop:
			ora	TempA			; put R.G.B. enhance control bits into Video Control.
			sta	VideoControl

			ldy	#0Ah
			jsr	WaitNMI

			txa
			clc
			adc	#00100000b		; let (D5-D7) increase by 1 only.
			cmp	#11100000b		; D5-D7 = 1?
			beq	?FadeOutOK

			tax
			bne	?FadeOutLoop

	?FadeOutOK:
			ora	TempA
			sta	VideoControl
			sta	VideoControlBuff

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ColorFadeIn
;	Function		: Control screen color fade in function from dark to normal by 7 steps.
;	Input Parameter	: VideoControlBuff - Current display status.
;	Return Parameter	: VideoControlBuff - screen On with normal color status.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ColorFadeIn:
			lda	VideoControlBuff	; get current status of Video Control register.
			and	#00011111b		; disable D7-D5 for ready to Fade-In process.
			sta	TempA

			ldx	#11100000b
			txa

	?FadeInLoop:
			ora	TempA			; put R.G.B. enhance control bits into Video Control.
			sta	VideoControl

			ldy	#0Ah
			jsr	WaitNMI

			txa
			sec
			sbc	#00100000b		; let (D5-D7) subtract by 1 only.
			tax
			bne	?FadeInLoop

			ora	TempA
			sta	VideoControl
			sta	VideoControlBuff

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: YChangeScreenPage
;	Function		: Change screen page from 2 to 3 or from 3 to 2.
;	Input Parameter	: ScreenControlBuff - Current screen page status.
;	Return Parameter	: ScreenControlBuff - New screen page status.
;-------------------------------------------------------------------------------------------------------------------------------------
;
YChangeScreenPage:
			lda	SystemControlBuff	; get current System Control register and current page
			and	#00000010b		; number for identify what page is the new page.

			bne	?SetToPage0

	?SetToPage1:
			lda	SystemControlBuff
			ora	#00000010b		; set new screen page to page 1.
			bne	?SetScreenPage

	?SetToPage0:
			lda	SystemControlBuff
			and	#11111101b		; set new screen page to page 0.

	?SetScreenPage:
			sta	SystemControlBuff
			sta	SystemControl

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: XChangeScreenPage
;	Function		: Change screen page from 0 to 1 or from 1 to 0.
;	Input Parameter	: ScreenControlBuff - Current screen page status.
;	Return Parameter	: ScreenControlBuff - New screen page status.
;-------------------------------------------------------------------------------------------------------------------------------------
;
XChangeScreenPage:
			lda	SystemControlBuff	; get current System Control register and current page
			and	#00000001b		; number for identify what page is the new page.

			bne	?SetToPage0

	?SetToPage1:
			lda	SystemControlBuff
			ora	#00000001b		; set new screen page to page 1.
			bne	?SetScreenPage

	?SetToPage0:
			lda	SystemControlBuff
			and	#11111110b		; set new screen page to page 0.

	?SetScreenPage:
			sta	SystemControlBuff
			sta	SystemControl

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: UpScrollBG
;	Function		: Move background to Up by 1 pixel.
;	Input Parameter	: PositionX - Current X axis position register.
;				  PositionY - Y axis position register.
;	Return Parameter	: PositionX - New X axis position register.
;-------------------------------------------------------------------------------------------------------------------------------------
;
UpScrollBG:
			ldx	PositionY		; get current Y axis position and decrease by 1
			inx
			bne	?SetPosition		; if new position down count to 0, then set new screen page 							; for new position, else goto set new position only.
			jsr	YChangeScreenPage

	?SetPosition:
			stx	PositionY
			lda	PositionX

			sta	ScreenPosition
			stx	ScreenPosition

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: DownScrollBG
;	Function		: Move background to Down by 1 pixel.
;	Input Parameter	: PositionX - Current X axis position register.
;				  PositionY - Y axis position register.
;	Return Parameter	: PositionX - New X axis position register.
;-------------------------------------------------------------------------------------------------------------------------------------
;
DownScrollBG:
			ldx	PositionY		; get current X axis position and decrease by 1.
			dex
			cpx	#FFh
			bne	?SetPosition		; if new position down count to 0, then set new screen page 							; for new position, else goto set new position only.
			jsr	YChangeScreenPage

	?SetPosition:
			stx	PositionY
			lda	PositionX

			sta	ScreenPosition
			stx	ScreenPosition

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: RightScrollBG
;	Function		: Move background to left by 1 pixel.
;	Input Parameter	: PositionX - Current X axis position register.
;				  PositionY - Y axis position register.
;	Return Parameter	: PositionX - New X axis position register.
;-------------------------------------------------------------------------------------------------------------------------------------
;
RightScrollBG:
			ldx	PositionX		; get current X axis position and decrease by 1
			inx
			bne	?SetPosition		; if new position down count to 0, then set new screen page 							; for new position, else goto set new position only.
			jsr	XChangeScreenPage

	?SetPosition:
			stx	PositionX
			lda	PositionY

			stx	ScreenPosition
			sta	ScreenPosition

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: LeftScrollBG
;	Function		: Move background to right by 1 pixel.
;	Input Parameter	: PositionX - Current X axis position register.
;				  PositionY - Y axis position register.
;	Return Parameter	: PositionX - New X axis position register.
;-------------------------------------------------------------------------------------------------------------------------------------
;
LeftScrollBG:
			ldx	PositionX		; get current X axis position and decrease by 1.
			dex
			cpx	#FFh
			bne	?SetPosition		; if new position down count to 0, then set new screen page 							; for new position, else goto set new position only.
			jsr	XChangeScreenPage

	?SetPosition:
			stx	PositionX
			lda	PositionY

			stx	ScreenPosition
			sta	ScreenPosition

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ReadJoystick
;	Function		: Read 8 bits data from Joystic 1, then read 8 bits data from Joystick 2.
;	Input Parameter	: None.
;	Return Parameter	: Joystick1Data - Data register of Joystick 1.
;						D0 - Right direction key;
;						D1 - Left direction key;
;						D2 - Down direction key;
;						D3 - Up direction key;
;						D4 - Start key;
;						D5 - Select key;
;						D6 - Button B;
;						D7 - Button A;
;				  Joystick2Data - Data register of Joystick 2.
;						D0 - Right direction key;
;						D1 - Left direction key;
;						D2 - Down direction key;
;						D3 - Up direction key;
;						D4 - Start key;
;						D5 - Select key;
;						D6 - Button B;
;						D7 - Button A;
;-------------------------------------------------------------------------------------------------------------------------------------
;
ReadJoystick:
			lda	StrobeControlBuff
			ora	#00000001b
			sta	StrobeControl		; set read data strobe to Joystick 1 & 2.
			and	#11111110b
			sta	StrobeControl

			ldx	#08h			; set X as loop counter for read 8 bits data.
	?ReadJoy1:
			lda	StrobeControl		; get 1 bit data of Joystick 1 from Strobe Control port.

			ror	A
			rol	Joystick1Data
			dex
			bne	?ReadJoy1

			lda	MouseExist		; check for identify Mouse exist?
			bne	?ReadJoystickOK	; if mouse exist then stop read Joystick 2, else read the
							; Joystick data from the Joystick 2.
			lda	StrobeControlBuff
			ora	#00000001b
			sta	StrobeControl		; set read data strobe to Joystick 1 & 2.
			and	#11111110b
			sta	StrobeControl

			ldx	#08h			; set X as loop counter for read 8 bits data.
	?ReadJoy2:
			lda	Joystick2Control	; get 1 bit data of Joystick 2 from Joystick 2 Control port.
			ror	A
			rol	Joystick2Data
			dex
			bne	?ReadJoy2

	?ReadJoystickOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ScrollColor
;	Function		: Scroll the 64 bytes color code on color pallete for special effect.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ScrollColor:
			lda	ScrollCounter
			cmp	#01h
			bcc	?ProcessOK

			ldx	#14d			; set X register as move counter for 14 colors.
			ldy	#01h

	?FirstMoveLoop:
			lda	CellTempBuffer+16,y	; move pallete 1 to buffer.
			sta	WorkBuffer+16,y

			lda	CellTempBuffer+32,y	; move pallete 2 to buffer.
			sta	WorkBuffer+32,y

			lda	CellTempBuffer+48,y	; move pallete 3 to buffer.
			sta	WorkBuffer+48,y

			iny
			dex
			bne	?FirstMoveLoop

			lda	#14d
			sta	TempX

			ldy	#01h
			ldx	#02h

	?SecondMoveLoop:
			lda	WorkBuffer+16,y	; move pallete 1 back and shift.
			sta	CellTempBuffer+16,x

			lda	WorkBuffer+32,y	; move pallete 2 back and shift.
			sta	CellTempBuffer+32,x

			lda	WorkBuffer+48,y	; move pallete 3 back and shift.
			sta	CellTempBuffer+48,x

			iny
			inx
			cpx	#15d
			bne	?CountLoop

			ldx	#01h

	?CountLoop:
			dec	TempX
			bne	?SecondMoveLoop

			lda	#<CellTempBuffer
			sta	PalleteAddr
			lda	#>CellTempBuffer
			sta	PalleteAddrH

			lda	#04h
			sta	PalleteMode
			jsr	TransferColor		; call for transfer Background Color Pallete.

			lda	#00h
			sta	ScrollCounter

	?ProcessOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: TransferColor
;	Function		: Transfer 16/64 bytes of Color Pallete data into Color Pallete register.
;	Input Parameter	: PalleteMode - Decide for which pallete will be filled.
;						 0 = Nothing to transfer;
;						 1 = Background Pallete;
;						 2 = Sprite Pallete;
;						 3 = Both Background and Sprite Pallete;
;						 4 = 64 Bytes color data for NT6578 mode;
;				  PalleteAddr - Low byte address for start address of Pallete Table.
;				  PalleteAddrH - High byte address for start address of Pallete Table.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
TransferColor:
			ldy	PalleteMode
			beq	TransferOK		; if mode = 0 then quit transfer process.

			tya
			and	#11111100b
			bne	?Mode76

			lda	SystemControlBuff	; get current status of System Control register.
			and	#11111011b		; set VRAM address counter to +1 mode.
			sta	SystemControl

			lda	VideoControlBuff	; get current  status of Video Control register.
			and	#11100111b		; disable Sprite and Background display function for ready
							; to transfer one page background data into VRAM.
			sta	VideoControl

			ldx	#10h			; set Y as transfer length for 16Bytes of Pallete data.
			lda	#3Fh
			sta	VRAMAddress	; set high byte destination address($3FX0h) of VRAM.

			dey
			bne	?Mode2
	?Mode1:
			lda	#00h			; set low byte address to $3F00h
			bne	?ModeOK

	?Mode2:
			dey
			bne	?Mode3
			lda	#10h			; set low byte address to $3F10h
			bne	?ModeOK

	?Mode3:
			lda	#00h			; set low byte address to $3F00h
			ldx	#20h			; set Y as transfer length for 32 Bytes of Pallete data.

	?ModeOK:
			sta	VRAMAddress		; set low byte destination address of VRAM.

			ldy	#00h
	?FillPallete:
			lda	(PalleteAddr),y		; get pallete data from source table.
			sta	VRAMData

			iny
			dex				; transfer 16 of 32 bytes? if not finish yet then keep loop.
			bne	?FillPallete
			beq	?RestoreConfig

	?Mode76:
			lda	#00h			; setup bank select of DMA source to Bank 1 for
			sta	DMASourceBank	; background PGT data.

			lda	#3Fh
			sta	DMALengthL		; setup low byte of DMA length.
			lda	#00h			; setup high byte of DMA length.
			sta	DMALengthH		; for total transfer length = $003F + 1 = 0040h bytes.

			lda	PalleteAddr		; setup low byte address of DMA source and destination.
			sta	DMASourceL
			lda	PalleteAddrH		; setup high byte address of DMA source and destination.
			sta	DMASourceH

			lda	#40h
			sta	DMADestinationL
			lda	#20h
			sta	DMADestinationH

			lda	#11100000b		; enable DMA mode 3 for move background PGT data from
;			sta	DMAFlag
			sta	DMAControl		; buffer to $2040~$207F of pallete.

			jmp	TransferOK

	?RestoreConfig:
			lda	SystemControlBuff	; re-store original status of System Control register.
			sta	SystemControl

			lda	VideoControlBuff	; re-store original data of Video Control Register.
			sta	VideoControl	
	TransferOK:
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: InitBGColorPallete16
;	Function		: Transfer 64 bytes of Color Pallete data into Color Pallete register
;				  for Background Graphic.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
InitBGColorPallete16:
			lda	#<GirlColor		; get and set Background Color Pallete table address.
			sta	IndexAddr
			lda	#>GirlColor
			sta	IndexAddrH

			lda	#<CellTempBuffer
			sta	PageBuffAddr
			lda	#>CellTempBuffer
			sta	PageBuffAddrH

			ldx	#40h
			ldy	#00h

	?MoveLoop:
			lda	(IndexAddr),y		; move 64 bytes of color code into page buffer for
			sta	(PageBuffAddr),y	; special effect process.

			iny
			dex
			bne	?MoveLoop

			lda	#<CellTempBuffer
			sta	PalleteAddr
			lda	#>CellTempBuffer
			sta	PalleteAddrH

			lda	#04h
			sta	PalleteMode
			jsr	TransferColor		; call for transfer Background Color Pallete.

			rts
;	
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ClearWorkRAM
;	Function		: clear all of the RAM area from $0000h~$1FFFh and $5000h~$57FFh
;				  execpt the stack buffer region where locate on $0100h~$01FFh.
;	Input Parameter	: None.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ClearWorkRAM:
			lda	#00h
			sta	TempA			; setup default value for clear work RAM.

			jsr	ClearZeroPage 	; goto clear zero page region.
			jsr	ClearWorkArea	; goto clear the region of $0200h~$07FFh.
			jsr	ClearBackupRAM	; goto clear the region of $6000h~$7FFFh.
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ClearZeroPage
;	Function		: clear all data on the RAM from $0000h~$00FFh.
;	Input Parameter	: TempA - Default value for preset to RAM.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ClearZeroPage:
			lda	TempA
			ldy	#20h

	?ClearZeroLoop:
			sta	$00h,y			; clear the memory of zero page with Y index.
			dey
			bne	?ClearZeroLoop

			sta	$00h,y			; clear the memory of zero page with Y 
			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ClearBackupRAM
;	Function		: clear all data on the RAM from $6000h~$7FFFh.
;	Input Parameter	: TempA - Default value for preset to RAM.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ClearBackupRAM:
			ldx	#32D			; set X register as page counter for $60XXh~$7FXXh

			lda	#60h
			sta	IndexAddrH		; preset high byte address of indirect index register.
			lda	#00h
			sta	IndexAddr		; preset low byte address of indirect index register.

	?ClearWorkLoop:
			jsr	ClearPageRAM	; goto clear one page data who index by IndexAddr and
							; IndexAddrH.
			inc	IndexAddrH		; increase high byte addrees counter by 1 untill page
			dex				; counter decress to 0.
			bne	?ClearWorkLoop

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ClearWorkArea
;	Function		: clear all data on the RAM from $0200h~$07FFh.
;	Input Parameter	: TempA - Default value for preset to RAM.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ClearWorkArea:
			ldx	#06d			; set X register as page counter for $02XXh~$07XXh
			lda	#02h
			sta	IndexAddrH		; preset high byte address of indirect index register.
			lda	#00h
			sta	IndexAddr		; preset low byte address of indirect index register.

	?ClearWorkLoop:
			jsr	ClearPageRAM	; goto clear one page data who index by IndexAddr and
							; IndexAddrH.
			inc	IndexAddrH		; increase high byte addrees counter by 1 untill page
			dex				; counter decress to 0.
			bne	?ClearWorkLoop

			rts
;
;-------------------------------------------------------------------------------------------------------------------------------------
;	Subroutine Name	: ClearPageRAM
;	Function		: clear all data of a page on the RAM from $XX00h~$XXFFh.
;	Input Parameter	: IndexAddr - low byte address of destination.
;				  IndexAddrH - high byte address of destination.
;				  TempA - Default value for preset to RAM.
;	Return Parameter	: None.
;-------------------------------------------------------------------------------------------------------------------------------------
;
ClearPageRAM:
			lda	TempA
			ldy	#0

	?ClearPageLoop:
			sta	(IndexAddr),y		; clear the memory of a page who index by 
							; IndexAddr and IndexAddrH with Y index.
			iny
			bne	?ClearPageLoop

			rts
;
;	End of Subroutine section
;=====================================================================
;
;=====================================================================
;	NMI interrupt service routine
;=====================================================================
;
NMI:
			php
			pha
			tya
			pha
			txa
			pha

	?CheckSystemDMA:
			lda	DMAFlag
			bne	?CheckPPU

			lda	#00h
			sta	DMAFlag

	?CheckSpriteChange:
			lda	SpriteChange
			beq	?CheckPPU

 			lda	#>SpriteBuffer
			sta	SpriteDMASource	; trigger Sprite DMA Source address port for transfer
							; new sprite data into PPU.
			lda	#00h
			sta	SpriteChange		; clear Sprite Change flag after DMA transfer.

		ifdef	DemoVersion
			ldx	#FFh
			stx	SpriteStartAddress
			lda	SpriteBuffer,x
			sta	SpriteDataPort
			lda	#00h
			sta	SpriteStartAddress
		endif

	?CheckPPU:
;			lda	PPUStatus		; debug process, may be not need on NT6578
			inc	NMICounter
			inc	ScrollCounter

			jsr	ReadJoystick

	?CheckXOffset:
			lda	XOffsetEnable		; check X offset enable flag, if not enable then
			beq	EndOfNMI		; end of NMI routine.

			lda	#11100000b		; setup System Timer Counter for 64uS per period.
			sta	SystemTimerControl	; and use H-Blank as clock source.

			inc	XOffsetIndex
			lda	XOffsetIndex
			sta	TempX

EndOfNMI:
			pla
			tax
			pla
			tay
			pla
			plp
			rti
;
;=====================================================================
;	Interrupt service routine
;=====================================================================
;
IRQ:
			pha
			php
			txa
			pha
			tya
			pha

			lda	SystemIRQStatus	; check system interrupt status for find out what kind of
			bne	?IRQServiceStart	; interrupt occurs else exit IRQ service routine.
			jmp	?IRQFinish

	?IRQServiceStart:
			sta	IRQTemp

	?CheckInt1IRQ:
			lda	IRQTemp
			and	#00000010b
			beq	?CheckTimerIRQ

			ora	SystemIRQMaskBuff	; clear Keyboard Interrput flag.
			sta	SystemIRQMask

	?CheckTimerIRQ:
			lda	IRQTemp
			and	#10000000b
			beq	?CheckMouseIRQ

			ora	SystemIRQMaskBuff	; clear Timer Interrput flag.
			sta	SystemIRQMask

			jsr	TimerVectorJump	; jump to related service routine.

	?CheckMouseIRQ:
			lda	IRQTemp
			and	#01000000b
			beq	?CheckKeyboardIRQ

			ora	SystemIRQMaskBuff	; clear Mouse Interrput flag.
			sta	SystemIRQMask

			jsr	MouseService		; goto Mouse Interrupt service routine.

	?CheckKeyboardIRQ:
			lda	IRQTemp
			and	#00100000b
			beq	?CheckInt4IRQ

			ora	SystemIRQMaskBuff	; clear Keyboard Interrput flag.
			sta	SystemIRQMask

			lda	#00000000b
			sta	KeyboardControl

			lda	KeyboardCmd
			bne	?KeyboardService

			jsr	PS2MouseService	; goto PS/2 Mouse Service routine.
;			jmp	?CheckInt4IRQ
			jmp	?IRQFinish

	?KeyboardService:
			lda	KeyboardDataIn	; get keyboard data from keyboard input port.
			sta	KeyboardData

			lda	#80h
			sta	KeyboardInterrupt	; setup Keyboard Interrupt flag.

	?CheckInt4IRQ:
			lda	IRQTemp
			and	#00010000b
			beq	?CheckInt3IRQ

	?CheckInt3IRQ:
			lda	IRQTemp
			and	#00001000b
			beq	?CheckInt2IRQ

	?CheckInt2IRQ:
			lda	IRQTemp
			and	#00000100b
			beq	?RestoreIRQ

	?RestoreIRQ:
			lda	SystemIRQMaskBuff	; restore original System IRQ mask.
			sta	SystemIRQMask

	?IRQFinish:
			pla
			tay
			pla
			tax
			plp
			pla
			rti
;
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;			Interrupt and Reset vector table
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;
Vector			.Section	Offset FFFAH
NMIVector		.DW	NMI			; NMI Interrupt Service Routine
ResetVector		.DW	Reset			; Main Program Entery
InterruptVector	.DW	IRQ			; Interrupt Service Routine
;
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;                                 PROGRAM END                               (E)
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
               END

;******************************************************************************

